// audio
datablock AudioProfile(bullpupFire1Sound)
{
   filename    = "./bullpup_fire.wav";
   description = AudioClose3d;
   preload = true;
};

// datablock AudioProfile(bullpupFire2Sound)
// {
//    filename    = "./bullpup_fire.wav";
//    description = AudioClose3d;
//    preload = true;
// };

// datablock AudioProfile(bullpupFire3Sound)
// {
//    filename    = "./bullpup_fire.wav";
//    description = AudioClose3d;
//    preload = true;
// };

// datablock AudioProfile(bullpupFire4Sound)
// {
//    filename    = "./bullpup_fire.wav";
//    description = AudioClose3d;
//    preload = true;
// };

AddDamageType("Bullpup",   '<bitmap:add-ons/Weapon_Package_Tier2A/ci_Bullpup> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2A/ci_Bullpup> %1',0.75,1);
datablock ProjectileData(BullpupProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 17;
   directDamageType    = $DamageType::Bullpup;
   radiusDamageType    = $DamageType::Bullpup;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 80;
   verticalImpulse     = 40;
   explosion           = gunExplosion;

   muzzleVelocity      = 150;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(BullpupItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./bullpup.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Bullpup";
	iconName = "./bullpup";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = BullpupImage;
	canDrop = true;

	TT_ammoType = "556";
   TT_reloads = true;
   TT_maxAmmo = 21;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BullpupImage)
{
   // Basic Item properties
	shapeFile = "./bullpup.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BullpupItem;
   ammo = " ";
   projectile = BullpupProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BullpupItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Some state names are abbreviated
   // Something about too many states and/or names that are too long screws up the image
   // Should use fewer states but using looping states makes the burst fire too slow

   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.05;
   stateTransitionOnTimeout[0]       = "LoadCheckA";
   stateSound[0]					= weaponSwitchSound;

   stateName[1]                     = "Ready";
   stateTransitionOnNotLoaded[1]       = "Reload";
   stateTransitionOnTriggerDown[1]  = "FireCheckA";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "BurstCheck1A";
   stateTimeoutValue[2]            = 0.064; // 0.08
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateScript[2]                  = "onFire";
   stateEjectShell[2]       	  = true;
   stateEmitter[2]					= gunFlashEmitter;
   stateEmitterTime[2]				= 0.05;
   stateEmitterNode[2]				= "muzzleNode";
   stateSound[2]					= BullpupFire1Sound;

   stateName[3]			= "Delay";
   stateTransitionOnTimeout[3]     = "FireLoadCheckA";
   stateTimeoutValue[3]            = 0.06;
   stateEmitter[3]					= gunSmokeEmitter;
   stateEmitterTime[3]				= 0.03;
   stateEmitterNode[3]				= "muzzleNode";

   stateName[4]				= "LoadCheckA";
   stateScript[4]				= "TT_onLoadCheck";
   stateTimeoutValue[4]			= 0.01;
   stateTransitionOnTimeout[4]		= "LoadCheckB";

   stateName[5]				= "LoadCheckB";
   stateTransitionOnLoaded[5]		= "Ready";
   stateTransitionOnNotLoaded[5]		= "Empty";

   stateName[6]				= "Reload";
   stateTimeoutValue[6]			= 1.6;
   stateScript[6]				= "onReloadStart";
   stateTransitionOnTimeout[6]		= "Wait";

   stateName[7]				= "Wait";
   stateTimeoutValue[7]			= 0.8;
   stateScript[7]				= "onReloadWait";
   stateTransitionOnTimeout[7]		= "Reloaded";

   stateName[8]				= "FireLoadCheckA";
   stateScript[8]				= "TT_onLoadCheck";
   stateTimeoutValue[8]			= 0.01;
   stateTransitionOnTimeout[8]		= "FireLoadCheckB";

   stateName[9]				= "FireLoadCheckB";
   stateTransitionOnLoaded[9]		= "Smoke";
   stateTransitionOnNotLoaded[9]		= "ReloadSmoke";

   stateName[10] 				= "Smoke";
   stateEmitter[10]			= gunSmokeEmitter;
   stateEmitterTime[10]			= 0.3;
   stateEmitterNode[10]			= "muzzleNode";
   stateTimeoutValue[10]			= 0.2;
   stateTransitionOnTimeout[10]		= "Ready";
   stateTransitionOnTriggerDown[10]	= "FireCheckA";

   stateName[11] 				= "ReloadSmoke";
   stateEmitter[11]			= gunSmokeEmitter;
   stateEmitterTime[11]			= 0.3;
   stateEmitterNode[11]			= "muzzleNode";
   stateTimeoutValue[11]			= 0.2;
   stateTransitionOnTimeout[11]		= "Empty";

   stateName[12]				= "Reloaded";
   stateTimeoutValue[12]			= 0.01;
   stateScript[12]				= "onReloaded";
   stateTransitionOnTimeout[12]		= "Ready";

   stateName[13]                    = "Fire1";
   stateTransitionOnTimeout[13]     = "BurstCheck2A";
   stateTimeoutValue[13]            = 0.064; // 0.08
   stateFire[13]                    = true;
   stateAllowImageChange[13]        = false;
   stateScript[13]                  = "onBurstFire";
   stateEjectShell[13]       	  = true;
   stateEmitter[13]					= gunFlashEmitter;
   stateEmitterTime[13]				= 0.05;
   stateEmitterNode[13]				= "muzzleNode";
   stateSound[13]					= BullpupFire1Sound;
   stateTransitionOnNotLoaded[13]      = "DryFire1";

   stateName[14]                    = "Fire2";
   stateTransitionOnTimeout[14]     = "Delay";
   stateTimeoutValue[14]            = 0.08;
   stateFire[14]                    = true;
   stateAllowImageChange[14]        = false;
   stateScript[14]                  = "onBurstFire";
   stateEjectShell[14]       	  = true;
   stateEmitter[14]					= gunFlashEmitter;
   stateEmitterTime[14]				= 0.05;
   stateEmitterNode[14]				= "muzzleNode";
   stateSound[14]					= BullpupFire1Sound;
   stateTransitionOnNotLoaded[14] = "DryFire2";

   stateName[15]                   = "Empty";
   stateTransitionOnLoaded[15]      = "Ready";
   stateTransitionOnAmmo[15]  = "Reload";
   stateTransitionOnTriggerDown[15]     = "FireCheckA";

   stateName[16]                   = "EmptyFire";
   stateScript[16]                 = "TT_onEmptyFire";
   stateTransitionOnLoaded[16]      = "Ready";
   stateTransitionOnAmmo[16]  = "Reload";
   stateTransitionOnTriggerUp[16]     = "Empty";

   stateName[17]                    = "FireCheckA";
   stateScript[17]                  = "TT_onFireCheck";
   stateTransitionOnTimeout[17]     = "FireCheckB";

   stateName[18]                    = "FireCheckB";
   stateTransitionOnLoaded[18]   	= "Fire";
   stateTransitionOnNotLoaded[18]      = "EmptyFire";

   stateName[19]                    = "DryFire1";
   stateTransitionOnTimeout[19]     = "DryFire2";
   stateTimeoutValue[19]            = 0.08;
   stateAllowImageChange[19]        = false;

   stateName[20]                    = "DryFire2";
   stateTransitionOnTimeout[20]     = "Delay";
   stateTimeoutValue[20]            = 0.08;
   stateAllowImageChange[20]        = false;

   stateName[21]                    = "BurstCheck1A";
   stateScript[21]                  = "onBurstCheck";
   stateTimeoutValue[21]            = 0.032;
   stateTransitionOnTimeout[21]     = "BurstCheck1B";

   stateName[22]                    = "BurstCheck1B";
   stateTransitionOnLoaded[22]      = "Fire1";
   stateTransitionOnNotLoaded[22]   = "DryFire1";

   stateName[23]                    = "BurstCheck2A";
   stateScript[23]                  = "onBurstCheck";
   stateTimeoutValue[23]            = 0.032;
   stateTransitionOnTimeout[23]     = "BurstCheck2B";

   stateName[24]                    = "BurstCheck2B";
   stateTransitionOnLoaded[24]      = "Fire2";
   stateTransitionOnNotLoaded[24]   = "DryFire2";
};

function BullpupImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0002;
	}
	else
	{
		%spread = 0.0004;
	}
	%shellCount = 1;

	%obj.lastShotTime = getSimTime();

	%obj.playThread(2, plant);

   %this.TT_decrementAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

	%this.TT_displayAmmo(%obj);

	return %p;
}

// Main purpose of onBurstFire and onBurstCheck is to stop bullpup taking ammo from other inventory items
// and possibly getting negative ammo
function BullpupImage::onBurstFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   if(vectorLen(%obj.getVelocity()) < 0.1)
   {
      %spread = 0.0002;
   }
   else
   {
      %spread = 0.0004;
   }
   %shellCount = 1;

   %obj.lastShotTime = getSimTime();

   %obj.playThread(2, plant);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

   %p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

   return %p;
}

function BullpupImage::onBurstCheck(%this, %obj, %slot)
{
   if(%this.TT_canFire(%obj))
   {
      %obj.setImageLoaded(%slot, 1);
      %this.TT_decrementAmmo(%obj);
      %this.TT_displayAmmo(%obj);
   }
   else
   {
      %obj.setImageLoaded(%slot, 0);
   }
}

function BullpupImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function BullpupImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function BullpupImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}
