//FlakCannon.cs;

datablock AudioProfile(FlakCannonFireSound)
{
   filename    = "./flak_cannon_fire.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ParticleData(FlakCannonBlastSparkParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 150;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
   colors[0]     = "1 1 1.0 0.1";
   colors[1]     = "1 1 1.0 0.1";
   colors[2]     = "1 1 1 0.0";

	sizes[0]	= 0.15;
	sizes[1]	= 0.55;
   sizes[2]	= 0.15;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(FlakCannonBlastSparkEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FlakCannonBlastSparkParticle";
};

datablock ParticleData(FlakCannonBlastExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 800;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.9 0.5 0.0 0.2";
   colors[1]     = "0.0 0.0 0.0 0.2";
   colors[2]     = "0.0 0.0 0.0 0.0";

	sizes[0]	= 6.0;
	sizes[1]	= 7.0;
   sizes[2]	= 1.5;

	times[0]	= 0.0;
	times[1]	= 0.28;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(FlakCannonBlastExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "FlakCannonBlastExplosionParticle";
};

datablock ParticleData(FlakCannonBlastExplosionParticle2)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 1990;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
   colors[0]     = "1 1 0.0 0.1";
   colors[1]     = "1 1 0.0 0.2";
   colors[2]     = "1 1 1 0.0";

	sizes[0]	= 0.21;
	sizes[1]	= 0.21;
   sizes[2]	= 0.1;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(FlakCannonBlastExplosionEmitter2)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   lifetimeMS       = 120;
   ejectionVelocity = 9;
   velocityVariance = 9.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FlakCannonBlastExplosionParticle2";
};

datablock ExplosionData(FlakCannonBlastExplosion)
{
   //explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   emitter[0] = FlakCannonBlastExplosionEmitter2;
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";

   particleEmitter = FlakCannonBlastExplosionEmitter;
   particleDensity = 20;
//   particleDensity = 0;
   particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 8;
   impulseForce = 1000;

   damageRadius = 8;
   radiusDamage = 20;

	// uiName = "Flak Cloud"; // doesn't show up
};

AddDamageType("FlakCannonDirect",   '<bitmap:add-ons/Weapon_Package_Explosive2/CI_Grenade_launcher> %1',    '%2 <bitmap:add-ons/Weapon_Package_Explosive2/CI_Grenade_launcher> %1',1,1);
datablock ProjectileData(FlakCannonProjectile)
{
   projectileShapeName = "./grenade_projectile.2.dts";
   directDamage        = 100;
   directDamageType = $DamageType::FlakCannonDirect;
   radiusDamageType = $DamageType::FlakCannonDirect;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = flakcannonBlastExplosion;
   particleEmitter     = GrenadeSmokeEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 76;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 98;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 60;
   velInheritFactor    = 0.0;

   armingDelay         = 1500;
   lifetime            = 1500;
   fadeDelay           = 1500;
   bounceElasticity    = 0.9;
   bounceFriction      = 0.0;
   isBallistic         = true;
   gravityMod = 0.2;
   explodeOnPlayerImpact = true;
   explodeondeath = true;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Flak Round";

	//PrjLoop System Fields
	PrjLoop_enabled = true;
	PrjLoop_maxTicks = 190;
	PrjLoop_tickTime = 200;
};

datablock ProjectileData(FlakCannonSparkProjectile)
{
//   projectileShapeName = "./nailgrenadedeployed.dts";
   directDamage        = 10;
   directDamageType  = $DamageType::FlakCannonDirect;
   radiusDamageType  = $DamageType::FlakCannonDirect;
   impactImpulse	   = 200;
   verticalImpulse	   = 200;
   particleEmitter     = FlakCannonBlastSparkEmitter;
   explosion           = FlakCannonBlastExplosion;

   muzzleVelocity      = 29;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;             
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 20;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   explodeOnDeath = true;
   armingDelay         = 00; 
   lifetime            = 70;
   fadeDelay           = 70;
   bounceElasticity    = 0.6;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 0.8;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(FlakCannonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   	shapeFile = "./CALIBRE_CANNON.DTS";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Flak Cannon";
	iconName = "./grenadelauncher";
	doColorShift = true;
	colorShiftColor = "0.20 0.20 0.2 1.000";

	 // Dynamic properties defined by the scripts
	image = FlakCannonImage;
	canDrop = true;

	TT_ammoType = "Bomb";
	TT_reloads = true;
	TT_maxAmmo = 1;
	TT_alwaysReloadPref = "Ex";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FlakCannonImage)
{
   // Basic Item properties
   	shapeFile = "./CALIBRE_CANNON.DTS";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FlakCannonItem;
   ammo = " ";
   projectile = FlakCannonProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 0; // 700

   doColorShift = true;
   colorShiftColor = FlakCannonItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.35;
	stateSound[0]					= weaponSwitchSound;
	stateTransitionOnTimeout[0]       = "LoadCheckA";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "FireCheckA";
	stateTransitionOnNotLoaded[1]		= "ReloadStart";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.01;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateEmitter[2]			  = shotgunExplosionRingEmitter;
	stateEmitterTime[2]		  = 0.03;
	stateScript[2]                  = "onFire";
	stateSound[2]					= FlakCannonFireSound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "ReloadStart";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "TT_onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnLoaded[5]		= "Ready";
	stateTransitionOnNotLoaded[5]		= "Empty";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 1.2;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.4;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "TT_onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnLoaded[9]		= "Ready";
	stateTransitionOnAmmo[9]		= "Reload";
	stateTransitionOnNoAmmo[9]    = "Empty";

	stateName[10]                   = "Empty";
	stateTransitionOnLoaded[10]     = "Ready";
	stateTransitionOnAmmo[10]  = "ReloadStart";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                    = "EmptyFire";
	stateScript[11]                  = "TT_onEmptyFire";
	stateTransitionOnLoaded[11]      = "Ready";
	stateTransitionOnAmmo[11]        = "ReloadStart";
	stateTransitionOnTriggerUp[11]   = "Empty";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.1;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Activate";

	stateName[13]                    = "FireCheckA";
	stateScript[13]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[13]     = "FireCheckB";

	stateName[14]                    = "FireCheckB";
	stateTransitionOnLoaded[14]   = "Fire";
	stateTransitionOnNotLoaded[14]      = "EmptyFire";

	stateName[15]                     = "ReloadStart";
	stateTransitionOnTimeout[15]  = "FireLoadCheckA";
	stateTimeoutValue[15]            = 0.1;
	stateAllowImageChange[15]         = false;
};

function FlakCannonProjectile::PrjLoop_onTick(%this, %obj)
{
	%emittedPrj = FlakCannonSparkProjectile;
	%speed = 20;
	%amount = 4;
	PrjLoop_emitPrj(%obj, %emittedPrj, %speed, %amount);
}

function FlakCannonProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	// serverPlay3D(FlakCannonBounceSound,%obj.getTransform());
	for(%i=0;%i<getRandom(3,5);%i++)
	{
		%a=getRandom(0,360)/360*2*$pi;
		%b=getRandom(0,360)/360*2*$pi;
		
		%vec=mcos(%a) SPC msin(%a) SPC mcos(%b);
		
		%p=new Projectile()
		{
			datablock=FlakCannonSparkProjectile;
			
			initialVelocity=vectorScale(%vec,200);
			initialPosition=%obj.getPosition();
			
			client=%obj.client;
			sourceObject=%obj.sourceobject;
			sourceSlot=%obj.sourceslot;
		};
		MissionCleanup.add(%p);
	}
	Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}

function FlakCannonImage::onFire(%this, %obj, %slot)
{
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	return Parent::onFire(%this,%obj,%slot);
}

function FlakCannonImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftDown);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function FlakCannonImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, plant);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function FlakCannonImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, block_PlantBrick_Sound);
	%this.TT_displayAmmo(%obj);
}