AddDamageType("ClassicBRifle",   '<bitmap:add-ons/Weapon_Skins_RiflesT2/CI_rifle_b> %1',    '%2 <bitmap:add-ons/Weapon_Skins_RiflesT2/CI_rifle_b> %1',0.75,1);
datablock ProjectileData(ClassicBattleRifleProjectile1 : BattleRifleProjectile1)
{
   directDamage        = 18;
   directDamageType    = $DamageType::ClassicBRifle;
   radiusDamageType    = $DamageType::ClassicBRifle;
};

datablock ItemData(ClassicBattleRifleItem : BattleRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Classic_BR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Classic B.Rifle";
	iconName = "./classicbattlerifle";
	doColorShift = true;
	colorShiftColor = "0.59 0.56 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = ClassicBattleRifleImage;
	canDrop = true;

	TT_ammoType = "708";
	TT_reloads = true;
	TT_maxAmmo = 24;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ClassicBattleRifleImage : BattleRifleImage)
{
   // Basic Item properties
   shapeFile = "./Classic_BR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ClassicBattleRifleItem;
   ammo = " ";
   projectile = ClassicBattleRifleProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ClassicBattleRifleItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
};

function ClassicBattleRifleImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0010;
	}
	else
	{
		%spread = 0.0020;
	}
	%shellCount = 1;

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ClassicBattleRifleImage::onReloadStart(%this,%obj,%slot)
{           		
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftright);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ClassicBattleRifleImage::onReloading(%this,%obj,%slot)
{           		
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function ClassicBattleRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function ClassicBattleRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function BattlerifleProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.2);
   }
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}
