AddDamageType("HuntingRifle",   '<bitmap:add-ons/Weapon_Skins_Rifles/ci_classic_rifle> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Rifles/ci_classic_rifle> %1',0.75,1);
AddDamageType("HuntingRifleHeadshot",   '<bitmap:add-ons/Weapon_Skins_Rifles/ci_classic_rifle> <bitmap:add-ons/Weapon_Package_Tier1/CI_tactheadshot>%1',    '%2 <bitmap:add-ons/Weapon_Skins_Rifles/ci_classic_rifle> <bitmap:add-ons/Weapon_Package_Tier1/CI_tactheadshot>%1',0.75,1);

////////////////////////////////////////////////////////////////////////////////////////////////projectile
datablock ProjectileData(HuntingRifleProjectile : SportRifleProjectile)
{
   // directDamage        = sportrifleprojectile.directdamage; //90
   directDamageType    = $DamageType::HuntingRifle;
   radiusDamageType    = $DamageType::HuntingRifle;
};

datablock ProjectileData(HuntingRifleWeakProjectile : SportRifleWeakProjectile)
{
   directDamageType    = $DamageType::HuntingRifle;
   radiusDamageType    = $DamageType::HuntingRifle;
};


////////////////////////////////////////////////////////////////////////////////////////////////item
datablock ItemData(HuntingRifleItem : SportRifleItem)
{
	shapeFile = "./sport_carbine.dts";
	uiName = "Hunting Rifle";
	iconName = "./huntingrifle";
	colorShiftColor = "0.5 0.53 0.52 1.000";
	image = HuntingRifleImage;
	TT_ammoType = "556";
	TT_reloads = true;
	TT_maxAmmo = 8;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HuntingRifleImage : SportRifleImage)
{
   shapeFile = "./sport_carbine.dts";
   item = HuntingRifleItem;
   projectile = HuntingRifleProjectile;
   projectileType = Projectile;
   doColorShift = true;
   colorShiftColor = HuntingRifleItem.colorShiftColor;

   stateSequence[3]          = "";
};


function HuntingRifleImage::onFire(%this,%obj,%slot)
{
   %obj.playThread(2, shiftAway);
   
   if(vectorLen(%obj.getVelocity()) < 4 && (getSimTime() - %obj.lastShotTime) > 1000)
   {
      %projectile = %this.projectile;
      %spread = 0.0000;
   }
   else
   {
      %projectile = HuntingRifleWeakProjectile;
      %spread = 0.0009;
   }
   %shellCount = 1;
   
   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function HuntingRifleImage::onReloadStart(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, shiftRight);
   serverPlay3D(block_MoveBrick_Sound, %obj.getPosition());
}

function HuntingRifleImage::onReloadWait(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, plant);
   serverPlay3D(magazineOutSound, %obj.getPosition());
}

function HuntingRifleImage::onReloaded(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return %obj.setImageLoaded(%slot, 1);
   %this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
   %this.TT_displayAmmo(%obj);
}

function HuntingRifleProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 3, $DamageType::HuntingRifleHeadshot);
}

function HuntingRifleWeakProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 2, $DamageType::HuntingRifleHeadshot);
}