AddDamageType("ClassicSniperRifle",   '<bitmap:add-ons/Weapon_Skins_Sniper/CI_Classic_Sniper> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Sniper/CI_Classic_Sniper> %1',0.75,1);
AddDamageType("ClassicSniperRifleHeadshot",   '<bitmap:add-ons/Weapon_Skins_Sniper/CI_Classic_Sniper> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Sniper/CI_Classic_Sniper> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',0.75,1);

datablock ProjectileData(clasmilTracerProjectile : pistolTracerProjectile)
{
   directDamage        = 2;
   directDamageType    = $DamageType::ClassicSniperRifle;
   muzzleVelocity      = 200;
   radiusDamageType    = $DamageType::ClassicSniperRifle;
};

//////////
// item //
//////////
datablock ItemData(ClassicSniperRifleItem : MilitarySniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Classic_Sniper.1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Classic Sniper";
	iconName = "./ClassicSniper";
	doColorShift = true;
	colorShiftColor = "0.59 0.56 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = ClassicSniperRifleImage;
	canDrop = true;

	TT_ammoType = "270";
	TT_reloads = true;
	TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ClassicSniperRifleImage : MilitarySniperImage)
{
	TT_raycastEnabled = true;
   TT_raycastWeaponRange = 700;
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = shotgunBlastProjectile;
   TT_raycastTracerProjectile = clasmilTracerProjectile;
   TT_raycastCritTracerProjectile = clasmilTracerProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastCritDirectDamageType = $DamageType::ClassicSniperRifleHeadshot;
   TT_raycastDirectDamage = 33; //Varies
   TT_raycastDirectDamageType = $DamageType::ClassicSniperRifle;
   TT_raycastSpreadAmt = 0; //Varies
	shapeFile = "./Classic_Sniper.1.dts";
   emap = true;
   item = ClassicSniperRifleItem;
   ammo = " ";
   projectile = clasmilTracerProjectile;
   projectileType = Projectile;
   doColorShift = true;
   colorShiftColor = ClassicSniperRifleItem.colorShiftColor;
};

function ClassicSniperRifleImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function ClassicSniperRifleImage::onReloaded1(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ClassicSniperRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	serverPlay3D(block_ChangeBrick_Sound,%obj.getPosition());
	%obj.playThread(2, shiftRight);
}

function ClassicSniperRifleImage::onSmoke(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function ClassicSniperRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function ClassicSniperRifleImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");
	
	Parent::onFire(%this,%obj,%slot);

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
}

function ClassicSniperRifleImage::TT_isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal, %hit)
{
   return TT_isRaycastHeadshot(%this, %obj, %slot, %col, %pos, %normal, %hit);
}