datablock ItemData(ClassicPistolItem : PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./CLASSIC_PISTOL.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Classic Pistol";
	iconName = "./Classicpistol";
	doColorShift = true;
	colorShiftColor = "0.51 0.43 0.36 1";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = ClassicPistolImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 10;
};

////////////////
//weapon image//
////////////////
AddDamageType("ClassicL4Pistol",   '<bitmap:add-ons/Weapon_Skins_Pistol/ci_Classic_pistol> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Pistol/ci_Classic_pistol> %1',0.75,1);
datablock ShapeBaseImageData(ClassicPistolImage : PistolImage)
{
   TT_raycastDirectDamage = 15;

   shapeFile = "./CLASSIC_PISTOL.dts";
   // Projectile && Ammo.
   item = ClassicPistolItem;
   doColorShift = true;
   colorShiftColor = ClassicPistolItem.colorShiftColor;

   TT_raycastDirectDamageType = $DamageType::ClassicL4Pistol;
};

function ClassicPistolImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0018;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0009;
		%this.TT_raycastWeaponRange = 200;
	}
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
}

function ClassicPistolImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function ClassicPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ClassicPistolImage::onBounce(%this,%obj,%slot)
{	
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function ClassicPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, pistolClickSound, plant);
	%this.TT_displayAmmo(%obj);
}