AddDamageType("ClassicLMG",   '<bitmap:add-ons/Weapon_Skins_LMG/CI_drumLMG> %1',    '%2 <bitmap:add-ons/Weapon_Skins_LMG/CI_drumLMG> %1',0.75,1);
datablock ProjectileData(ClassicLMGProjectile1 : LightMachinegunProjectile1)
{
   directDamage        = 10;
   directDamageType    = $DamageType::ClassicLMG;
   radiusDamageType    = $DamageType::ClassicLMG;
};

datablock ItemData(ClassicLMGItem : LightMachinegunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./drum_lmg.1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Drum LMG";
	iconName = "./drumlmg";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.45 1.000";

	 // Dynamic properties defined by the scripts
	image = ClassicLMGImage;
	canDrop = true;

	TT_ammoType = "556";
   TT_reloads = true;
   TT_maxAmmo = 70;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ClassicLMGImage : LightMachinegunImage)
{
	shapeFile = "./drum_lmg.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = ClassicLMGItem;
   ammo = " ";
   projectile = ClassicLMGProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ClassicLMGItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
};

function ClassicLMGImage::onFire(%this,%obj,%slot)
{ 
	%evec = %obj.getEyeVector();
	%eZ = getWord(%evec,2);

	%aimVec = "0" SPC "0" SPC %eZ;

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-1")));
	
	%obj.lastShotTime = getSimTime();

	%shellCount = 1;
	%spread = 0.0015;
	// never true because of second clause
	// if(vectorLen(%obj.getVelocity()) < 0.1) && (getSimTime() - %obj.lastShotTime) > 1000)
	// {
	// 	%spread = 0.0002;
	// }
	// else
	// {
	// 	%spread = 0.0015;
	// }
	%projectile = %this.projectile;

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ClassicLMGImage::onFire2(%this,%obj,%slot)
{
	%evec = %obj.getEyeVector();
	%eZ = getWord(%evec,2);

	%aimVec = "0" SPC "0" SPC %eZ;

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-1")));
	
	%obj.lastShotTime = getSimTime();

	%shellCount = 1;
	%spread = 0.0004;
	// never true because of second clause
	// if(vectorLen(%obj.getVelocity()) < 0.1) && (getSimTime() - %obj.lastShotTime) > 1000)
	// {
	// 	%spread = 0.0002;
	// }
	// else
	// {
	// 	%spread = 0.0004;
	// }
	%projectile = %this.projectile;

	%obj.playThread(2, plant);

	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ClassicLMGImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	//%obj.popDatablock(LMGArmor.getID());
}

function ClassicLMGImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function ClassicLMGImage::onClick(%this,%obj,%slot)
{
	%obj.pushDatablock(LMGArmor.getID());
}

function ClassicLMGImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function ClassicLMGImage::onHalt(%this,%obj,%slot)
{
	%this.TT_displayAmmo(%obj);
	%obj.popDatablock(LMGArmor.getID());
}

function ClassicLMGImage::onEmptyTransition(%this,%obj,%slot)
{
   %obj.popDatablock(LMGArmor.getID());
}

function ClassicLMGImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   %obj.popDatablock(LMGArmor.getID());
}

function ClassicLMGProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.2);
   }
	parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}