datablock AudioProfile(SingleShotgunFireSound)
{
   filename    = "./super_Shotgun_fire2.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("SingleShotgun",   '<bitmap:add-ons/Weapon_Package_Tier1A/huntingshotgun_CI> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier1A/huntingshotgun_CI> %1',0.75,1);
datablock ProjectileData(SingleShotgunProjectile : PumpShotgunProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 9; //14
   directDamageType    = $DamageType::SingleShotgun;
   radiusDamageType    = $DamageType::SingleShotgun;
};

datablock ProjectileData(SingleShotgunBlastProjectile : ShotgunBlastProjectile)
{
   directDamage        = 98; //14
   directDamageType    = $DamageType::SingleShotgun;
   radiusDamageType    = $DamageType::SingleShotgun;
};

//////////
// item //
//////////
datablock ItemData(SingleShotgunItem : PumpShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	 // Basic Item Properties
	shapeFile = "./single_shotgun_.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	//gui stuff
	uiName = "Single Shotgun";
	iconName = "./SingleShotgun";
	doColorShift = true;
	colorShiftColor = "0.43 0.38 0.3 1";
	 // Dynamic properties defined by the scripts
	image = SingleShotgunImage;
	canDrop = true;

	TT_ammoType = "Shotgun";
	TT_reloads = true;
	TT_maxAmmo = 1;
	TT_alwaysReloadPref = "NonEx";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SingleShotgunImage)
{
   // Basic Item properties
	shapeFile = "./single_shotgun_.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0.03 -.02";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = SingleShotgunItem;
   ammo = " ";
   projectile = SingleShotgunProjectile;
   projectileType = Projectile;
   casing = PumpShotgunShellDebris;
	armready = true;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   doColorShift = true;
   colorShiftColor = SingleShotgunItem.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "FireCheckA";
	stateTransitionOnNotLoaded[1]       = "ReloadStart";
	stateScript[1]                  = "onReady";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.01;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSound[2]					= SingleShotgunFireSound;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "ReloadStart";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "TT_onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnLoaded[5]		= "Ready";
	stateTransitionOnNotLoaded[5]		= "Empty";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 0.288; // 0.3
	stateScript[6]				= "onReloadStart";
	stateSequence[6]                  = "reload_Open";
	stateTransitionOnTimeout[6]		= "DeathCheck";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.3;
	stateSequence[7]                  = "reload_Close";
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	stateTransitionOnNoAmmo[7]       = "Empty";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "TT_onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnLoaded[9]		= "Ready";
	stateTransitionOnAmmo[9]		= "Reload";
	stateTransitionOnNoAmmo[9]    = "Empty";
	
	stateName[10]                   = "Empty";
	stateTransitionOnLoaded[10]     = "Ready";
	stateTransitionOnAmmo[10]  = "ReloadStart";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                   = "EmptyFire";
	stateScript[11]                 = "TT_onEmptyFire";
	stateTransitionOnLoaded[11]      = "Ready";
	stateTransitionOnAmmo[11]       = "ReloadStart";
	stateTransitionOnTriggerUp[11]    = "Empty";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.04;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

	stateName[13]                     = "ReloadStart";
	stateTransitionOnTimeout[13]  = "ReloadStartB";
	stateTimeoutValue[13]            = 0.1;
	stateAllowImageChange[13]         = false;

	stateName[14]                     = "ReloadStartB";
	stateTransitionOnTimeout[14]  = "FireLoadCheckA";
	stateTimeoutValue[14]            = 0.01;

	stateName[15]                    = "FireCheckA";
	stateScript[15]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[15]     = "FireCheckB";

	stateName[16]                    = "FireCheckB";
	stateTransitionOnLoaded[16]   = "Fire";
	stateTransitionOnNotLoaded[16]      = "EmptyFire";

	stateName[17]                   = "DeathCheck";
	stateScript[17]                 = "TT_onDeathCheck";
	stateTimeoutValue[17]           = 0.032;
	stateTransitionOnTimeout[17]    = "Wait";
};

function SingleShotgunImage::onFire(%this,%obj,%slot)
{
	TT_knockback(%obj, -4, -4, -4);

	serverPlay3D(SingleShotgunfireSound,%obj.getPosition());
	%obj.playThread(2, activate);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

	//shotgun blast projectile: only effective at point blank, sends targets flying off into the distance
	//
	//more or less represents the concussion blast. i can only assume such a thing exists because
	// i've never stood infront of a fucking shotgun before
	///////////////////////////////////////////////////////////

	TT_createProjectile(%this, %obj, %slot, SingleShotgunBlastProjectile, 1);

	%projectile = %this.projectile;
	%spread = 0.0014;
	%shellCount = 5;

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function SingleShotgunImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftDown);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function SingleShotgunImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function SingleShotgunImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot);
	%this.TT_displayAmmo(%obj);
}
