datablock AudioProfile(l4bGuitarHitSoundA)
{
	filename    = "./guitar_hit_world_01.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(l4bGuitarHitSoundB)
{
	filename    = "./guitar_hit_world_02.wav";
	description = AudioClose3d;
	preload = true;
};

//////////
// item //
//////////
datablock ItemData(l4bGuitarItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./electric_guitar_.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Electric Guitar";
	iconName = "./electricguitar";
	doColorShift = false;
	//colorShiftColor = "0.64 0.1 0.1 1.000";

	 // Dynamic properties defined by the scripts
	image = l4bGuitarImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
AddDamageType("L4BGuitar",   '<bitmap:Add-Ons/Weapon_Melee_Extended/ci_electric_guitar> %1',    '%2 <bitmap:Add-Ons/Weapon_Melee_Extended/ci_electric_guitar> %1',0.75,1);
datablock ShapeBaseImageData(l4bGuitarImage)
{
   shapeFile = "./electric_guitar_.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.0 -0.1 0.0";
   rotation = eulerToMatrix("-20 0 0");
   eyeOffset = "0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   className = "WeaponImage";

   // Projectile && Ammo.
   item = l4bGuitarItem;
   ammo = " ";
   projectile = hammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = l4bGuitarItem.colorShiftColor;
   
   TT_raycastEnabled = true;
   TT_raycastWeaponRange = 3;
   TT_raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   TT_raycastExplosionProjectile = hammerProjectile;
   TT_raycastExplosionBrickSound = l4bGuitarHitSoundA;
   TT_raycastExplosionPlayerSound = l4bGuitarHitSoundB;
   TT_raycastDirectDamage = 55;
   TT_raycastDirectDamageType = $DamageType::L4BGuitar;
   
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateSequence[0]                 = "Activate";
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]                  = "onActivate";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.05;
	stateTransitionOnTimeout[2]     = "FireA";
	
	stateName[3]                    = "FireA";
	stateTransitionOnTimeout[3]     = "FireB";
	stateTimeoutValue[3]            = 0.10;
	stateAllowImageChange[3]        = false;
	stateSound[3]			= TT_MeleeSwingSound;
	stateWaitForTimeout[3]		= true;

	stateName[4]                    = "FireB";
	stateTransitionOnTimeout[4]     = "Wait";
	stateTimeoutValue[4]            = 0.15;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;
	
	stateName[5]			= "Wait";
	stateTransitionOnTimeout[5]	= "CheckFire";
	stateTimeoutValue[5]		= 0.1;
	stateScript[5]			= "onStopFire";
	stateAllowImageChange[5]	= false;
	stateWaitForTimeout[5]		= true;

	stateName[6]			= "CheckFire";
	stateTransitionOnTriggerUp[6]	= "StopFire";
	stateTransitionOnTriggerDown[6]	= "PreFire";
	
	stateName[7]                    = "StopFire";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.2;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	stateSequence[7]                = "StopFire";
	stateScript[7]                  = "onStopFire";
};

function l4bGuitarImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0)
		return;

	%obj.playThread(2, shiftTo);

	if(getRandom(0,1))
	{
		%this.TT_raycastExplosionBrickSound = l4bGuitarHitSoundA;
		%this.TT_raycastExplosionPlayerSound = l4bGuitarHitSoundA;
	}
	else
	{
		%this.TT_raycastExplosionBrickSound = l4bGuitarHitSoundB;
		%this.TT_raycastExplosionPlayerSound = l4bGuitarHitSoundB;
	}

	Parent::onFire(%this, %obj, %slot);
}

function l4bGuitarImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(2, activate);
}

function l4bGuitarImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, shiftAway);
}

function l4bGuitarImage::TT_isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit)
{
	return TT_isMeleeRaycastCrit(%this,%obj,%slot,%col,%pos,%normal,%hit);
}
