//audio
datablock AudioProfile(LightMachinegunFire1Sound)
{
   filename    = "./LMG_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(LightMachinegunClickSound)
{
   filename    = "./LMG_clickofdeath.wav";
   description = AudioClose3d;
   preload = true;
};

datablock PlayerData(LMGArmor : PlayerStandardArmor)
{
   runForce = 25 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 4;
   maxBackwardSpeed = 4;
   maxSideSpeed = 4;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 9 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "";
	showEnergyBar = false;
	firstpersononly = 1;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
   
   isSurvivor = 1;
};

AddDamageType("LMG",   '<bitmap:add-ons/Weapon_Package_Tier2/ci_lmg1> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2/ci_lmg1> %1',0.75,1);
datablock ProjectileData(LightMachinegunProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 12;
   directDamageType    = $DamageType::LMG;
   radiusDamageType    = $DamageType::LMG;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 300;
   verticalImpulse     = 20;
   explosion           = gunExplosion;

   muzzleVelocity      = 180;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.0;
   bounceFriction      = 0.0;
   isBallistic         = true;
   gravityMod = 0.7;
   explodeOnDeath = true;
   explodeOnPlayerImpact = false;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(LightMachinegunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./LMG.2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Light MG";
	iconName = "./lightmg";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.42 1.000";

	 // Dynamic properties defined by the scripts
	image = LightMachinegunImage;
	canDrop = true;

	TT_ammoType = "556";
	TT_reloads = true;
	TT_maxAmmo = 70;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(LightMachinegunImage)
{
   // Basic Item properties
   shapeFile = "./LMG.2.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = LightMachinegunItem;
   ammo = " ";
   projectile = LightMachinegunProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = LightMachinegunItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNotLoaded[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "ClickCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Fire2";
	stateTimeoutValue[2]            = 0.06;
	stateSound[2]				= LightMachinegunfire1Sound;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateEjectShell[2]       	  = true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.02;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "TT_onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnLoaded[5]		= "Ready";
	stateTransitionOnNotLoaded[5]		= "Empty";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 1.4;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.8;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "TT_onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnLoaded[9]		= "Smoke";
	stateTransitionOnNotLoaded[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateEmitter[10]			= gunSmokeEmitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Halt";
	stateTransitionOnTriggerDown[10]	= "FireCheckA";
	
	stateName[11] 				= "ReloadSmoke";
	stateEmitter[11]			= gunSmokeEmitter;
	stateEmitterTime[11]			= 0.3;
	stateEmitterNode[11]			= "muzzleNode";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "EmptyTransition";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.04;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

	stateName[13]			= "Halt";
	stateTransitionOnTimeout[13]     = "Ready";
	stateTimeoutValue[13]            = 0.3;
	stateEmitter[13]					= gunSmokeEmitter;
	stateEmitterTime[13]				= 0.48;
	stateEmitterNode[13]				= "muzzleNode";
	stateScript[13]                  = "onHalt";

	stateName[14]                     = "Click";
	stateTransitionOnTimeout[14]      = "FireCheckA";
	stateTimeoutValue[14]             = 0.2;
	stateScript[14]                   = "onClick";
	stateSound[14]				= LightMachinegunClickSound;
	stateTransitionOnNotLoaded[14]        = "EmptyFireTransition";

	stateName[15]                    = "Fire2";
	stateTransitionOnTimeout[15]     = "Delay";
	stateTimeoutValue[15]            = 0.03;
	stateSound[15]				= LightMachinegunfire1Sound;
	// stateFire[15]                    = true;
	stateAllowImageChange[15]        = false;
	stateScript[15]                  = "onFire2";
	stateEjectShell[15]       	  = true;
	stateEmitter[15]					= gunFlashEmitter;
	stateEmitterTime[15]				= 0.05;
	stateEmitterNode[15]				= "muzzleNode";

	stateName[16]                   = "Empty";
	stateTransitionOnLoaded[16]      = "Ready";
	stateTransitionOnAmmo[16]  = "Reload";
	stateTransitionOnTriggerDown[16]     = "ClickCheck";

	stateName[17]                    = "EmptyFire";
	stateScript[17]                  = "TT_onEmptyFire";
	stateTransitionOnLoaded[17]      = "Ready";
	stateTransitionOnAmmo[17]        = "Reload";
	stateTransitionOnTriggerUp[17]   = "Empty";

	stateName[18]                    = "ClickCheck";
	stateScript[18]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[18]     = "Click";

	stateName[19]                    = "FireCheckA";
	stateScript[19]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[19]     = "FireCheckB";

	stateName[20]                    = "FireCheckB";
	stateTransitionOnLoaded[20]   = "Fire";
	stateTransitionOnNotLoaded[20]      = "EmptyFireTransition";

	stateName[21]                    = "EmptyTransition";
	stateScript[21]                  = "onEmptyTransition";
	stateTransitionOnTimeout[21]     = "Empty";

	stateName[22]                    = "EmptyFireTransition";
	stateScript[22]                  = "onEmptyTransition";
	stateTransitionOnTimeout[22]     = "EmptyFire";
};

function LightMachinegunImage::onFire(%this,%obj,%slot)
{
	TT_knockback(%obj, 0, 0 ,-1);
	
	%obj.lastShotTime = getSimTime();

	%shellCount = 1;
	%spread = 0.0007;
	// never true because of second clause
	// if(vectorLen(%obj.getVelocity()) < 0.1) && (getSimTime() - %obj.lastShotTime) > 1000)
	// {
	// 	%spread = 0.0004;
	// }
	// else
	// {
	// 	%spread = 0.0007;
	// }
	%projectile = %this.projectile;

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function LightMachinegunImage::onFire2(%this,%obj,%slot)
{
	TT_knockback(%obj, 0, 0 ,-1);
	
	%obj.lastShotTime = getSimTime();

	%shellCount = 1;
	%spread = 0.0004;
	// never true because of second clause
	// if(vectorLen(%obj.getVelocity()) < 0.1) && (getSimTime() - %obj.lastShotTime) > 1000)
	// {
	// 	%spread = 0.0002;
	// }
	// else
	// {
	// 	%spread = 0.0004;
	// }
	%projectile = %this.projectile;

	%obj.playThread(2, plant);

	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function LightMachinegunImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	//%obj.popDatablock(LMGArmor.getID());
}

function LightMachinegunImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function LightMachinegunImage::onClick(%this,%obj,%slot)
{
	if($Pref::Server::TT::LMGSlow)
		%obj.pushDatablock(LMGArmor.getID());
}

function LightMachinegunImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function LightMachinegunImage::onHalt(%this,%obj,%slot)
{
	%this.TT_displayAmmo(%obj);
	%obj.popDatablock(LMGArmor.getID());
}

function LightMachinegunImage::onEmptyTransition(%this,%obj,%slot)
{
   %obj.popDatablock(LMGArmor.getID());
}

function LightMachinegunImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   %obj.popDatablock(LMGArmor.getID());
}

function LightMachinegunProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.2);
   }
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}
