datablock ParticleData(MachstilTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 60;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 0 1";
	colors[1]	= "1 1 0.4 1";
	colors[2]	= "1 1 1 1";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(MachstilTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MachstilTrailParticle;

   useEmitterColors = true;
};

datablock ProjectileData(MachstilTracerProjectile)
{
   directDamage        = 7;
   directDamageType    = $DamageType::L4MachStil;
   radiusDamageType    = $DamageType::L4MachStil;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 70;
//explosion           = gunExplosion;
   particleEmitter     = "MachstilTrailEmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(MachstilItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./machine_pistol.g.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Machine Pistol";
	iconName = "./machinepistol";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = MachstilImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 32;
};

////////////////
//weapon image//
////////////////
AddDamageType("Machstil",   '<bitmap:add-ons/Weapon_Package_Tier2a/machinepistol_ci> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2a/machinepistol_ci> %1',0.75,1);
datablock ShapeBaseImageData(MachStilImage)
{

   // Basic Item properties
   shapeFile = "./machine_pistol.g.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0.05";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MachStilItem;
   ammo = " ";
   projectile = MachstilTracerProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = MachStilItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   TT_raycastEnabled = true;
   TT_raycastWeaponRange = 200; //varies
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = GunProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastDirectDamage = 6; //10
   TT_raycastDirectDamageType = $DamageType::MachStil;
   TT_raycastSpreadAmt = 0.0006; //varies
   TT_raycastSpreadCount = 1;
   TT_raycastTracerProjectile = MachStilTracerProjectile;
   TT_raycastFromMuzzle = true;

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1]	= "ManualReload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";
	stateScript[1]                  = "onReady";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.001;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= pistolfireSound;

	stateName[3] 			= "Smoke";
	stateTimeoutValue[3]		= 0.01;
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3]	= "Wait";

	stateName[4]			= "Wait";
	stateEjectShell[4]              = true;
	stateTimeoutValue[4]		= 0.001;
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.005;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "Ready";
	stateTransitionOnNotLoaded[6]		= "Empty";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "ReloadStart";
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 1.088; // 1.1
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "DeathCheck";
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";
	stateSound[9]			= PistolClickSound;
	stateTransitionOnNoAmmo[9]       = "Empty";

	stateName[10]                   = "Empty";
	stateTransitionOnLoaded[10]      = "Ready";
	stateTransitionOnAmmo[10]  = "ReloadWait";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                   = "EmptyFire";
	stateScript[11]                 = "TT_onEmptyFire";
	stateTransitionOnLoaded[11]      = "Ready";
	stateTransitionOnAmmo[11]       = "ReloadWait";
	stateTransitionOnTriggerUp[11]    = "Empty";
	
	stateName[12]                   = "ManualReload";
	stateTransitionOnAmmo[12]  = "ReloadWait";
	stateTransitionOnNoAmmo[12]     = "ReloadStart";

	stateName[13]                   = "DeathCheck";
	stateScript[13]                 = "TT_onDeathCheck";
	stateTimeoutValue[13]           = 0.032;
	stateTransitionOnTimeout[13]    = "Reloaded";

	stateName[14]                    = "FireCheckA";
	stateScript[14]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[14]     = "FireCheckB";

	stateName[15]                    = "FireCheckB";
	stateTransitionOnLoaded[15]   = "Fire";
	stateTransitionOnNotLoaded[15]      = "EmptyFire";
};

function MachStilImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0024;
		%this.TT_raycastWeaponRange = 45;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0013;
		%this.TT_raycastWeaponRange = 100;
	}
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	
	%obj.playThread(2, plant);
}

function MachStilImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function MachStilImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick6Sound, plant);
	%this.TT_displayAmmo(%obj);
}
