datablock AudioProfile(SilencedSniperFireSound)
{
   filename    = "./sht.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("MagnifiedSniperRifle",   '<bitmap:add-ons/Weapon_Skins_Sniper/CI_Magnified_Sniper> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Sniper/CI_Magnified_Sniper> %1',0.75,1);
AddDamageType("MagnifiedSniperRifleHeadshot",   '<bitmap:add-ons/Weapon_Skins_Sniper/CI_Magnified_Sniper> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Sniper/CI_Magnified_Sniper> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',0.75,1);

datablock ProjectileData(magmilTracerProjectile : pistolTracerProjectile)
{
   directDamage        = 2;
   directDamageType    = $DamageType::MagnifiedSniperRifle;
   muzzleVelocity      = 200;
   radiusDamageType    = $DamageType::MagnifiedSniperRifle;
};

//////////
// item //
//////////
datablock ItemData(MagnifiedSniperRifleItem : MilitarySniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Silenced_Sniper.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Silenced Sniper";
	iconName = "./magnifiedsniper";
	doColorShift = true;
	colorShiftColor = "0.64 0.64 0.6 1.000";

	 // Dynamic properties defined by the scripts
	image = MagnifiedSniperRifleImage;
	canDrop = true;

	TT_ammoType = "270";
	TT_reloads = true;
	TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MagnifiedSniperRifleImage : MilitarySniperImage)
{
	TT_raycastEnabled = true;
   TT_raycastWeaponRange = 700;
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = shotgunBlastProjectile;
   TT_raycastTracerProjectile = magmilTracerProjectile;
   TT_raycastCritTracerProjectile = magmilTracerProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastCritDirectDamageType = $DamageType::MagnifiedSniperRifleHeadshot;
   TT_raycastDirectDamage = 33; //Varies
   TT_raycastDirectDamageType = $DamageType::MagnifiedSniperRifle;
   TT_raycastSpreadAmt = 0; //Varies
	shapeFile = "./Silenced_Sniper.dts";
   emap = true;
   item = MagnifiedSniperRifleItem;
   ammo = " ";
   projectile = magmilTracerProjectile;
   projectileType = Projectile;
   doColorShift = true;
   colorShiftColor = MagnifiedSniperRifleItem.colorShiftColor;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Wait2";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = silencedsniperfireSound;

	stateName[3] 			  = "Smoke";
	stateSequence[3]			  = "reload";
	stateSound[3]			  = boltriflereloadSound;
	stateTimeoutValue[3]            = 0.8;
	stateScript[3]                  = "onSmoke";
	stateTransitionOnTimeout[3]     = "Wait3";

};

function MagnifiedSniperRifleImage::onReloadStart(%this,%obj,%slot)
{           		
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function MagnifiedSniperRifleImage::onReloaded1(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function MagnifiedSniperRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	serverPlay3D(block_ChangeBrick_Sound,%obj.getPosition());
	%obj.playThread(2, shiftRight);
}

function MagnifiedSniperRifleImage::onSmoke(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}


function MagnifiedSniperRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
	// %obj.lastFireTime = getSimTime() - 400;
}

// function MagnifiedSniperRifleImage::onMount(%this,%obj,%slot)
// {
//    Parent::onMount(%this,%obj,%slot);
//    %obj.lastFireTime = getSimTime() - 500;
// }

function MagnifiedSniperRifleImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");
	
	Parent::onFire(%this,%obj,%slot);

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
}

function MagnifiedSniperRifleImage::TT_isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal, %hit)
{
   return TT_isRaycastHeadshot(%this, %obj, %slot, %col, %pos, %normal, %hit);
}