//audio
datablock AudioProfile(MatchPistolFireSound)
{
   filename    = "./Match_Pistol_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(MatchPistolTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 220;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.4 1 1 1";
	colors[1]	= "0.4 1 1 1";
	colors[2]	= "1 1 1 0.5";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(MatchPistolTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MatchPistolTrailParticle;

   useEmitterColors = true;
};

datablock ProjectileData(MatchPistolTracerProjectile)
{
   directDamage        = 0;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse	  = 50;
//explosion           = gunExplosion;
   particleEmitter     = "MatchPistolTrailEmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(MatchPistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Match_Pistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Match Pistol";
	iconName = "./MatchPistol";
	doColorShift = true;
	colorShiftColor = "0.9 0.9 0.95 1.000";

	 // Dynamic properties defined by the scripts
	image = MatchPistolImage;
	canDrop = true;

	TT_ammoType = "880";
	TT_reloads = true;
	TT_maxAmmo = 4;
};

AddDamageType("L4MatchPistol",   '<bitmap:base/client/ui/CI/generic> %1',    '%2 <bitmap:base/client/ui/CI/generic> %1',0.75,1);
// AddDamageType("L4MatchPistol",   '<bitmap:add-ons/Weapon_Package_Tier1/CI_MatchPistol> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier1/CI_MatchPistol> %1',0.75,1);

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MatchPistolImage)
{

   // Basic Item properties
	shapeFile = "./Match_Pistol.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MatchPistolItem;
   ammo = " ";
   projectile = MatchPistolTracerProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = MatchPistolItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   TT_raycastEnabled = true;
   TT_raycastWeaponRange = 200; //varies
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = GunProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastDirectDamage = 22; //10
   TT_raycastDirectDamageType = $DamageType::L4Pistol;
   TT_raycastSpreadAmt = 0.0002; //varies
   TT_raycastSpreadCount = 1;
   TT_raycastTracerProjectile = MatchPistolTracerProjectile;
   TT_raycastFromMuzzle = true;

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1]	= "ManualReload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";
	stateScript[1]                  = "onReady";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.15;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= MatchPistolfireSound;

	stateName[3] 			= "Smoke";
	stateTimeoutValue[3]            = 0.05;
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3]	= "Wait";

	stateName[4]			= "Wait";
	stateEjectShell[2]              = true;
	stateTimeoutValue[4]		= 0.001;
	stateScript[4]                  = "onBounce";
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	stateSound[4]			= PistolClickSound;
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "TT_onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "Ready";
	stateTransitionOnNotLoaded[6]		= "Empty";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "ReloadStart";
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 1.472; // 1.5
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "DeathCheck";
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.5;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";
	stateSequence[9]		= "Fire";
	stateSound[9]			= PistolClickSound;
	stateTransitionOnNoAmmo[9]     = "Empty";

	stateName[10]                    = "FireCheckA";
	stateScript[10]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[10]     = "FireCheckB";

	stateName[11]                    = "FireCheckB";
	stateTransitionOnLoaded[11]   = "Fire";
	stateTransitionOnNotLoaded[11]      = "EmptyFire";

	stateName[12]                   = "Empty";
	stateTransitionOnLoaded[12]      = "Ready";
	stateTransitionOnAmmo[12]  = "ReloadWait";
	stateTransitionOnTriggerDown[12]     = "FireCheckA";

	stateName[13]                   = "EmptyFire";
	stateScript[13]                 = "TT_onEmptyFire";
	stateTransitionOnLoaded[13]      = "Ready";
	stateTransitionOnAmmo[13]           = "ReloadWait";
	stateTransitionOnTriggerUp[13]    = "Empty";
	
	stateName[14]                   = "ManualReload";
	stateTransitionOnAmmo[14]  = "ReloadWait";
	stateTransitionOnNoAmmo[14]     = "ReloadStart";

	stateName[15]                   = "DeathCheck";
	stateScript[15]                 = "TT_onDeathCheck";
	stateTimeoutValue[15]           = 0.032;
	stateTransitionOnTimeout[15]    = "Reloaded";
};

function MatchPistolImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0004;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0002;
		%this.TT_raycastWeaponRange = 200;
	}
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);	
}

function MatchPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function MatchPistolImage::onBounce(%this,%obj,%slot)
{	
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function MatchPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function MatchPistolImage::TT_isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal, %hit)
{
   return TT_isRaycastHeadshot(%this, %obj, %slot, %col, %pos, %normal, %hit);
}