AddDamageType("MavMagnum",   '<bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum> %1',0.75,1);
AddDamageType("MavMagnumHeadshot",   '<bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum><bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum><bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',0.75,1);
datablock ProjectileData(MavMagnumProjectile : MagnumProjectile)
{
   directDamageType    = $DamageType::MavMagnum;
   radiusDamageType    = $DamageType::MavMagnum;
};

//////////
// item //
//////////
datablock ItemData(MavMagnumItem : MagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./Mav_magnum.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Mav Magnum";
	iconName = "./mavmagnum";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.46 1";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = MavMagnumImage;
	canDrop = true;

	TT_ammoType = "880";
	TT_reloads = true;
	TT_maxAmmo = 6;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MavMagnumImage : MagnumImage)
{
   // Basic Item properties
   shapeFile = "./Mav_magnum.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MavMagnumItem;
   ammo = " ";
   projectile = MavMagnumProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = MavMagnumItem.colorShiftColor;
};

function MavMagnumImage::onFire(%this,%obj,%slot)
{
	if(%this.TT_canFire(%obj))
	{
		%obj.playThread(2, shiftAway);
		serverPlay3D(MagnumFireSound,%obj.getPosition());

		%this.TT_decrementAmmo(%obj);

		if($Pref::Server::TT::Recoil)
			%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

		%projectile = %this.projectile;
		if(vectorLen(%obj.getVelocity()) < 0.1 && (getSimTime() - %obj.lastShotTime) > 500)
		{
			%spread = 0.0013;
		}
		else
		{
			%spread = 0.0000;
		}
		%shellCount = 1;

		// doesn't show up
		// TT_createProjectile(%this, %obj, %slot, shotgunFlashProjectile, 1);

		%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
	}
	%this.TT_displayAmmo(%obj);
	return %p;
}

function MavMagnumImage::onReloadDone(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function MavMagnumImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftright);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function MavMagnumImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_incrementReload(%obj, %slot, 1, reloadClick5Sound, shiftright);
	%this.TT_displayAmmo(%obj);
}

//needs more critical headshots. the magnum feels like a posing pistol right now :(
//using a weird offshoot of the huntsman's code for the moment
function MavMagnumProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 2, $DamageType::MavMagnumHeadshot);
}