AddDamageType("BlockyLMG",   '<bitmap:add-ons/Weapon_Skins_LMG/CI_BlockyLMG> %1',    '%2 <bitmap:add-ons/Weapon_Skins_LMG/CI_BlockyLMG> %1',0.75,1);
datablock ProjectileData(BlockyLMGProjectile1 : LightMachinegunProjectile1)
{
   directDamage        = 10;
   directDamageType    = $DamageType::BlockyLMG;
   radiusDamageType    = $DamageType::BlockyLMG;
};

datablock ItemData(BlockyLMGItem : LightMachinegunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Blocky_lmg_.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Blocky LMG";
	iconName = "./blockylmg";
	doColorShift = true;
	colorShiftColor = "0.6 0.6 0.64 1.000";

	 // Dynamic properties defined by the scripts
	image = BlockyLMGImage;
	canDrop = true;

	TT_ammoType = "556";
   TT_reloads = true;
   TT_maxAmmo = 65;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BlockyLMGImage : LightMachinegunImage)
{
	shapeFile = "./Blocky_lmg_.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BlockyLMGItem;
   ammo = " ";
   projectile = BlockyLMGProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BlockyLMGItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
};

function BlockyLMGImage::onFire(%this,%obj,%slot)
{
	TT_knockback(%obj, 0, 0, -1);
	
	%obj.lastShotTime = getSimTime();

	%shellCount = 1;
	%spread = 0.0025;
	// never true because of second clause
	// if(vectorLen(%obj.getVelocity()) < 0.1) && (getSimTime() - %obj.lastShotTime) > 1000)
	// {
	// 	%spread = 0.0012;
	// }
	// else
	// {
	// 	%spread = 0.0025;
	// }
	%projectile = %this.projectile;

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function BlockyLMGImage::onFire2(%this,%obj,%slot)
{
	TT_knockback(%obj, 0, 0, -1);
	
	%obj.lastShotTime = getSimTime();

	%shellCount = 1;
	%spread = 0.0004;
	// never true because of second clause
	// if(vectorLen(%obj.getVelocity()) < 0.1) && (getSimTime() - %obj.lastShotTime) > 1000)
	// {
	// 	%spread = 0.0002;
	// }
	// else
	// {
	// 	%spread = 0.0004;
	// }
	%projectile = %this.projectile;

	%obj.playThread(2, plant);

	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}


function BlockyLMGImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	//%obj.popDatablock(LMGArmor.getID());
}

function BlockyLMGImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function BlockyLMGImage::onClick(%this,%obj,%slot)
{
	%obj.pushDatablock(LMGArmor.getID());
}

function BlockyLMGImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function BlockyLMGImage::onHalt(%this,%obj,%slot)
{
	%this.TT_displayAmmo(%obj);
   %obj.popDatablock(LMGArmor.getID());
}

function BlockyLMGImage::onEmptyTransition(%this,%obj,%slot)
{
   %obj.popDatablock(LMGArmor.getID());
}

function BlockyLMGImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   %obj.popDatablock(LMGArmor.getID());
}

function BlockyLMGProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.5);
   }
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}