datablock ProjectileData(ModernMPTracerProjectile : MachstilTracerProjectile)
{
   directDamage        = 7;
   directDamageType    = $DamageType::L4ModernMP;
   radiusDamageType    = $DamageType::L4ModernMP;
   impactImpulse	     = 400;
   verticalImpulse	  = 350;
	//explosion           = gunExplosion;
};

//////////
// item //
//////////
datablock ItemData(ModernMPItem : MachstilItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./glock.mp.dts";
	uiName = "Modern MP";
	iconName = "./modernMP";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.3 1.000";
	image = ModernMPImage;
	canDrop = true;

  TT_ammoType = "9MM";
  TT_reloads = true;
  TT_maxAmmo = 32;
};

////////////////
//weapon image//
////////////////
AddDamageType("ModernMP",   '<bitmap:add-ons/Weapon_Package_Tier2a/machinepistol_ci> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2a/machinepistol_ci> %1',0.75,1);
datablock ShapeBaseImageData(ModernMPImage : MachstilImage)
{
   // Basic Item properties
	shapeFile = "./glock.mp.dts";
   emap = true;
   // Projectile && Ammo.
   item = ModernMPItem;
   ammo = " ";
   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   offset = "0 0 0";
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ModernMPItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   TT_raycastEnabled = true;
   TT_raycastWeaponRange = 200; //varies
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = GunProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastDirectDamage = 7; //10
   TT_raycastDirectDamageType = $DamageType::ModernMP;
   TT_raycastSpreadAmt = 0.0006; //varies
   TT_raycastSpreadCount = 1;
   TT_raycastTracerProjectile = MachstilTracerProjectile;
   TT_raycastFromMuzzle = true;

   // Initial start up state
};

function ModernMPImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0024;
		%this.TT_raycastWeaponRange = 45;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0013;
		%this.TT_raycastWeaponRange = 100;
	}
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	
	%obj.playThread(2, plant);
}

function ModernMPImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ModernMPImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick6Sound, plant);
	%this.TT_displayAmmo(%obj);
}