datablock ItemData(ModernPistolItem : PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./pistol_Modern.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Modern Pistol";
	iconName = "./Modernpistol";
	doColorShift = true;
	colorShiftColor = "0.6 0.6 0.6 1.000";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = ModernPistolImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 15;
};

////////////////
//weapon image//
////////////////
AddDamageType("ModernL4Pistol",   '<bitmap:add-ons/Weapon_Skins_Pistol/ci_Modern_pistol> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Pistol/ci_Modern_pistol> %1',0.75,1);
datablock ShapeBaseImageData(ModernPistolImage : PistolImage)
{
   TT_raycastDirectDamage = 13;

   shapeFile = "./pistol_Modern.dts";
   // Projectile && Ammo.
   item = ModernPistolItem;
   doColorShift = true;
   colorShiftColor = ModernPistolItem.colorShiftColor;

   TT_raycastDirectDamageType = $DamageType::ModernL4Pistol;
};

function ModernPistolImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0018;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0009;
		%this.TT_raycastWeaponRange = 200;
	}
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
}

function ModernPistolImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function ModernPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ModernPistolImage::onBounce(%this,%obj,%slot)
{	
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function ModernPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, pistolClickSound, plant);
	%this.TT_displayAmmo(%obj);
}