datablock ExplosionData(MortarExplosion : GrenaderExplosion)
{
   //explosionShape = "";

   explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";

   damageRadius = 15;
   radiusDamage = 90;

   impulseRadius = 16;
   impulseForce = 5000;
};

AddDamageType("MortarDirect",   '<bitmap:add-ons/Weapon_Package_Explosive2/CI_Grenade_launcher> %1',    '%2 <bitmap:add-ons/Weapon_Package_Explosive2/CI_Grenade_launcher> %1',1,1);
datablock ProjectileData(MortarProjectile : GrenaderProjectile)
{
   projectileShapeName = "./grenade_projectile.2.dts";
   directDamage        = 10;
   directDamageType = $DamageType::MortarDirect;
   radiusDamageType = $DamageType::MortarDirect;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = MortarExplosion;
   particleEmitter     = GrenadeSmokeEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 76;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 98;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity = 65;
   velInheritFactor    = 0.0;

   armingDelay         = 1000;
   lifetime            = 10000;
   fadeDelay           = 10000;
   bounceElasticity    = 0.2;
   bounceFriction      = 1.00;
   isBallistic         = true;
   gravityMod = 1;
   explodeOnPlayerImpact = true;
   explodeondeath = true;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Howitzer Grenade";
};

//////////
// item //
//////////
datablock ItemData(MortarItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./howitzer.DTS";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Howitzer";
	iconName = "./icon_Grenade_launcher";
	doColorShift = true;
	colorShiftColor = "0.40 0.40 0.42 1.000";
	l4ditemtype = "grenade";

	 // Dynamic properties defined by the scripts
	image = MortarImage;
	canDrop = true;

	TT_ammoType = "Bomb";
	TT_reloads = true;
	TT_maxAmmo = 1;
	TT_alwaysReloadPref = "Ex";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MortarImage)
{
   // Basic Item properties
   shapeFile = "./howitzer.DTS";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MortarItem;
   ammo = " ";
   projectile = MortarProjectile;
   projectileType = Projectile;

	//casing = MortarDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   // minShotTime = 700; //does nothing if not using Parent::onFire

   doColorShift = true;
   colorShiftColor = MortarItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.35;
	stateSound[0]              = weaponSwitchSound;
	stateTransitionOnTimeout[0]       = "LoadCheckA";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "FireCheckA";
	stateTransitionOnNotLoaded[1]		= "ReloadStart";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.01;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSound[2]					= GrenaderFireSound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "ReloadStart";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "TT_onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnLoaded[5]		= "Ready";
	stateTransitionOnNotLoaded[5]		= "Empty";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 1.2;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.4;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "TT_onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnLoaded[9]		= "Ready";
	stateTransitionOnAmmo[9]		= "Reload";
	stateTransitionOnNoAmmo[9]    = "Empty";

	stateName[10]                   = "Empty";
	stateTransitionOnLoaded[10]     = "Ready";
	stateTransitionOnAmmo[10]  = "ReloadStart";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                    = "EmptyFire";
	stateScript[11]                  = "TT_onEmptyFire";
	stateTransitionOnLoaded[11]      = "Ready";
	stateTransitionOnAmmo[11]        = "ReloadStart";
	stateTransitionOnTriggerUp[11]   = "Empty";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.1;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Activate";

	stateName[13]                    = "FireCheckA";
	stateScript[13]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[13]     = "FireCheckB";

	stateName[14]                    = "FireCheckB";
	stateTransitionOnLoaded[14]   = "Fire";
	stateTransitionOnNotLoaded[14]      = "EmptyFire";

	stateName[15]                     = "ReloadStart";
	stateTransitionOnTimeout[15]  = "FireLoadCheckA";
	stateTimeoutValue[15]            = 0.1;
	stateAllowImageChange[15]         = false;
};

function MortarImage::onFire(%this,%obj,%slot)
{
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);

	%dist = 100;
	%range = 300*getWord(%obj.getScale(),2);
	%start = %obj.getEyePoint();
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	%end = vectorAdd(%start,vectorScale(%aimVec,%range));
	%ray = containerRayCast(%start,%end,$TypeMasks::All,%obj);
	%target = firstWord(%ray);
	if(isObject(%target))
	{
		%pos = posFromRaycast(%ray);
		%dist = vectorDist(%obj.getPosition(),%pos);
	}
	%initVelocity = vectorScale(%obj.getMuzzleVector(%slot),18.25);
	%initVelocity = vectorAdd(%initVelocity,getRandom(0,3) / 6 SPC getRandom(0,3) / 6 SPC %dist / 3.75);
	%p = new (%this.projectileType)()
	{
		dataBlock = %this.projectile;
		initialVelocity = %initVelocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function MortarImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftDown);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function MortarImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, armReadyBoth);
}

function MortarImage::onUnMount(%this, %obj, %slot)
{
	fixArmReady(%obj);
	Parent::onUnMount(%this, %obj, %slot);
}

function MortarImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, plant);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function MortarImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, block_PlantBrick_Sound);
	%this.TT_displayAmmo(%obj);
}
