datablock AudioProfile(PeppergunFireSound)
{
   filename    = "./Pepperbox_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(PeppergunTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 120;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 0 1";
	colors[1]	= ".8 .8 0.4 1";
	colors[2]	= "1 1 1 1";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(PeppergunTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = PeppergunTrailParticle;

   useEmitterColors = true;
};

AddDamageType("PepperL4Pistol",   '<bitmap:add-ons/Weapon_package_tier1A/pepperbox_CI> %1',    '%2 <bitmap:add-ons/Weapon_package_tier1A/pepperbox_CI> %1',0.75,1);

datablock ProjectileData(PeppergunTracerProjectile)
{
   directDamage        = 3;
   directDamageType    = $DamageType::PepperL4Pistol;
   radiusDamageType    = $DamageType::PepperL4Pistol;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 150;
//explosion           = gunExplosion;
   particleEmitter     = "PeppergunTrailEmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ItemData(PepperPistolItem : PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./pepperbox.1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Pepperbox";
	iconName = "./pepperbox";
	doColorShift = true;
	colorShiftColor = "0.7 0.7 0.74 1.000";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = PepperPistolImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PepperPistolImage)
{
	shapeFile = "./pepperbox.1.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0.07 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	// Projectile && Ammo.
	item = PepperPistolItem;
	ammo = " ";
	projectile = PeppergunTracerProjectile;
	projectileType = Projectile;

	casing = GunShellDebris;
	shellExitDir        = "1.0 0.1 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 10.0;	
	shellVelocity       = 5.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = PepperPistolItem.colorShiftColor;

	TT_raycastEnabled = true;
	TT_raycastWeaponRange = 200; //varies
	TT_raycastWeaponTargets =
						 $TypeMasks::PlayerObjectType |    //AI/Players
						 $TypeMasks::StaticObjectType |    //Static Shapes
						 $TypeMasks::TerrainObjectType |    //Terrain
						 $TypeMasks::VehicleObjectType |    //Terrain
						 $TypeMasks::FXBrickObjectType;    //Bricks
	TT_raycastExplosionProjectile = GunProjectile;
	TT_raycastExplosionBrickSound = bulletHitSound;
	TT_raycastExplosionPlayerSound = bulletHitSound;
	TT_raycastDirectDamage = 7;
	TT_raycastDirectDamageType = $DamageType::PepperL4Pistol;
	TT_raycastSpreadAmt = 0.005; //varies
	TT_raycastSpreadCount = 4;
	TT_raycastTracerProjectile = PeppergunTracerProjectile;
	TT_raycastFromMuzzle = true;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1]	= "ManualReload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";

	stateName[2]                    = "FireCheckA";
	stateScript[2]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[2]     = "FireCheckB";

	stateName[3]                    = "FireCheckB";
	stateTransitionOnLoaded[3]   = "Fire";
	stateTransitionOnNotLoaded[3]      = "EmptyFire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Smoke";
	stateTimeoutValue[4]            = 0.2;
	stateTransitionOnTriggerUp[4] = "Smoke";
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateEjectShell[4]              = true;
	stateScript[4]                  = "onFire";
	stateSequence[4]		= "Fire";
	stateEmitter[4]			= gunFlashEmitter;
	stateEmitterTime[4]		= 0.05;
	stateEmitterNode[4]		= "muzzleNode";
	stateSound[4]			= peppergunfireSound;

	stateName[5] 			= "Smoke";
	stateEmitter[5]			= gunSmokeEmitter;
	stateEmitterTime[5]		= 0.1;
	stateTimeoutValue[5]            = 0.05;
	stateEmitterNode[5]		= "muzzleNode";
	stateTransitionOnTimeout[5]	= "Wait";

	stateName[6]			= "Wait";
	stateTimeoutValue[6]		= 0.001;
	stateScript[6]                  = "onBounce";
	stateTransitionOnTimeout[6]	= "LoadCheckA";
	stateSound[6]			= PistolClickSound;
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[7]				= "LoadCheckA";
	stateScript[7]				= "TT_onLoadCheck";
	stateTimeoutValue[7]			= 0.01;
	stateTransitionOnTimeout[7]		= "LoadCheckB";
	
	stateName[8]				= "LoadCheckB";
	stateTransitionOnLoaded[8]		= "Ready";
	stateTransitionOnNotLoaded[8]		= "Empty";
	
	stateName[9]				= "ReloadWait";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloadWait";
	stateTransitionOnTimeout[9]		= "ReloadStart";
	
	stateName[10]				= "ReloadStart";
	stateTimeoutValue[10]			= 1.088; //1.1
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "DeathCheck";
	
	stateName[11]				= "Reloaded";
	stateTimeoutValue[11]			= 0.3;
	stateScript[11]				= "onReloaded";
	stateTransitionOnTimeout[11]		= "Ready";
	stateSequence[11]		= "Fire";
	stateSound[11]			= PistolClickSound;
	stateTransitionOnNoAmmo[11]     = "Empty";

	stateName[12]                    = "DeathCheck";
	stateScript[12]                  = "TT_onDeathCheck";
	stateTimeoutValue[12]            = 0.032;
	stateTransitionOnTimeout[12]     = "Reloaded";

	stateName[13]                    = "ManualReload";
	stateTransitionOnAmmo[13]        = "ReloadWait";
	stateTransitionOnNoAmmo[13]      = "ReloadStart";

	stateName[14]                    = "Empty";
	stateTransitionOnLoaded[14]      = "Ready";
	stateTransitionOnAmmo[14]        = "ReloadWait";
	stateTransitionOnTriggerDown[14] = "FireCheckA";

	stateName[15]                    = "EmptyFire";
	stateScript[15]                  = "TT_onEmptyFire";
	stateTransitionOnLoaded[15]      = "Ready";
	stateTransitionOnAmmo[15]        = "ReloadWait";
	stateTransitionOnTriggerUp[15]   = "Empty";
};

function PepperpistolImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);	
}

function PepperPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function PepperPistolImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftDown);
	serverPlay3D(reloadClick5Sound,%obj.getPosition());
}

function PepperPistolImage::onBounce(%this,%obj,%slot)
{	
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function PepperPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, block_MoveBrick_Sound, plant);
	%this.TT_displayAmmo(%obj);
}
