AddDamageType("ClassicSubmachinegun",   '<bitmap:add-ons/Weapon_Skins_SMG/CI_Classic_smg> %1',    '%2 <bitmap:add-ons/Weapon_Skins_SMG/CI_Classic_smg> %1',0.75,1);
datablock ProjectileData(ClassicSubmachinegunProjectile1 : SubmachineGunProjectile1)
{
   directDamageType    = $DamageType::ClassicSubmachineGun;
   radiusDamageType    = $DamageType::ClassicSubmachineGun;
   directDamage        = 8+4;
};

//////////
// item //
//////////
datablock ItemData(ClassicSMGItem : SubmachinegunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./classic_SMG.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Classic SMG";
	iconName = "./Classicsmg";
	doColorShift = true;
	colorShiftColor = "0.51 0.43 0.36 1.000";

	 // Dynamic properties defined by the scripts
	image = ClassicSMGImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 35;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ClassicSMGImage : Submachinegunimage)
{
   // Basic Item properties
	shapeFile = "./classic_SMG.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ClassicSMGItem;
   ammo = " ";
   projectile = ClassicSubmachinegunProjectile1;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ClassicSMGItem.colorShiftColor;

	// stateTimeoutValue[3]            = 0.01;
};

function ClassicSMGImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	%spread = 0.0025;
	%shellCount = 1;

	%obj.playThread(2, plant);
	
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ClassicSMGImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, wrench);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ClassicSMGImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	serverPlay3D(magazineOutSound,%obj.getPosition());
	%obj.playThread(2, activate);
}

function ClassicSMGImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick6Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function ClassicSubmachinegunProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & $TypeMasks::PlayerObjectType)
	{
      TT_dampenVelocity(%col, 1.1);
	}
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}
