AddDamageType("RetroMagnum",   '<bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum> %1',0.75,1);
AddDamageType("RetroMagnumHeadshot",   '<bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum><bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Magnum/CI_Semiauto_Magnum><bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',0.75,1);
datablock ProjectileData(RetroMagnumProjectile : MagnumProjectile)
{
   directDamageType    = $DamageType::RetroMagnum;
   radiusDamageType    = $DamageType::RetroMagnum;
};

//////////
// item //
//////////
datablock ItemData(RetroMagnumItem : MagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./retro_magnum.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Retro Magnum";
	iconName = "./icon_Semiauto_Magnum";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.42 1";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = RetroMagnumImage;
	canDrop = true;

	TT_ammoType = "880";
	TT_reloads = true;
	TT_maxAmmo = 7;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RetroMagnumImage)
{
   // Basic Item properties
   shapeFile = "./retro_magnum.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RetroMagnumItem;
   ammo = " ";
   projectile = RetroMagnumProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = RetroMagnumItem.colorShiftColor;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.35;
	// stateSequence[0]		= "Activate";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1]	= "ManualReload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";
	// stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= MagnumfireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Wait";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.35;
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "TT_onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "Ready";
	stateTransitionOnNotLoaded[6]		= "Empty";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.6;
	stateTransitionOnTimeout[7]		= "ReloadStart";
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 0.6;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Reloaded";
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";

	stateName[10]                   = "Empty";
	stateTransitionOnAmmo[10]  = "ReloadWait";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                   = "EmptyFire";
	stateScript[11]                 = "TT_onEmptyFire";
	stateTransitionOnAmmo[11]           = "ReloadWait";
	stateTransitionOnTriggerUp[11]    = "Empty";
	
	stateName[12]                   = "ManualReload";
	stateTransitionOnAmmo[12]  = "ReloadWait";
	stateTransitionOnNoAmmo[12]     = "ReloadStart";

	stateName[13]                    = "FireCheckA";
	stateScript[13]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[13]     = "FireCheckB";

	stateName[14]                    = "FireCheckB";
	stateTransitionOnLoaded[14]   = "Fire";
	stateTransitionOnNotLoaded[14]      = "EmptyFire";
};

function RetroMagnumImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, shiftAway);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%spread = 0.0001;
	}
	else
	{
		%spread = 0;
	}
	%shellCount = 1;

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function RetroMagnumImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function RetroMagnumImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(reloadClick5Sound,%obj.getPosition());
}

function RetroMagnumImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, pistolClickSound, plant);
	%this.TT_displayAmmo(%obj);
}

//needs more critical headshots. the RetroMagnum feels like a posing pistol right now :(
//using a weird offshoot of the huntsman's code for the moment
function RetroMagnumProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 2, $DamageType::RetroMagnumHeadshot);
}