AddDamageType("SemiSniperRifle",   '<bitmap:add-ons/Weapon_Skins_Sniper/semisniper>  %1',    '%2 <bitmap:add-ons/Weapon_Skins_Sniper/semisniper> %1',0.75,1);
AddDamageType("SemiSniperRifleHeadshot",   '<bitmap:add-ons/Weapon_Skins_Sniper/semisniper> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Sniper/semisniper> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',0.75,1);

datablock ProjectileData(semimilTracerProjectile : pistolTracerProjectile)
{
   directDamage        = 3;
   directDamageType    = $DamageType::SemiSniperRifle;
   muzzleVelocity      = 200;
   radiusDamageType    = $DamageType::SemiSniperRifle;
};

//////////
// item //
//////////
datablock ItemData(SemiSniperRifleItem : MilitarySniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./anti_tank_rifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Retro Sniper";
	iconName = "./retrosniper";
	doColorShift = true;
	colorShiftColor = "0.5 0.53 0.52 1.000";

	 // Dynamic properties defined by the scripts
	image = SemiSniperRifleImage;
	canDrop = true;

	TT_ammoType = "270";
	TT_reloads = true;
	TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SemiSniperRifleImage : MilitarySniperImage)
{
	TT_raycastEnabled = true;
   TT_raycastWeaponRange = 700;
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = shotgunBlastProjectile;
   TT_raycastTracerProjectile = semimilTracerProjectile;
   TT_raycastCritTracerProjectile = semimilTracerProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastCritDirectDamageType = $DamageType::SemiSniperRifleHeadshot;
   TT_raycastDirectDamage = 33; //Varies
   TT_raycastDirectDamageType = $DamageType::SemiSniperRifle;
   TT_raycastSpreadAmt = 0; //Varies
	shapeFile = "./anti_tank_rifle.dts";
   emap = true;
   item = SemiSniperRifleItem;
   ammo = " ";
   projectile = semimilTracerProjectile;
   projectileType = Projectile;
   doColorShift = true;
   colorShiftColor = SemiSniperRifleItem.colorShiftColor;
};

function SemiSniperRifleImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function SemiSniperRifleImage::onReloaded1(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function SemiSniperRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	serverPlay3D(block_ChangeBrick_Sound,%obj.getPosition());
	%obj.playThread(2, shiftRight);
}

function SemiSniperRifleImage::onSmoke(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}


function SemiSniperRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function SemiSniperRifleImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");
	
	Parent::onFire(%this,%obj,%slot);

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
}

function SemiSniperRifleImage::TT_isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal, %hit)
{
   return TT_isRaycastHeadshot(%this, %obj, %slot, %col, %pos, %normal, %hit);
}