datablock ItemData(RetroPistolItem : PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./glock.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Retro Pistol";
	iconName = "./Retropistol";
	doColorShift = true;
	colorShiftColor = "0.6 0.6 0.63 1.000";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = RetroPistolImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 15;
};

////////////////
//weapon image//
////////////////
AddDamageType("RetroL4Pistol",   '<bitmap:base/client/ui/CI/generic> %1',    '%2 <bitmap:base/client/ui/CI/generic> %1',0.75,1);
datablock ShapeBaseImageData(RetroPistolImage : PistolImage)
{
   TT_raycastDirectDamage = 13;

   shapeFile = "./glock.dts";
   // Projectile && Ammo.
   item = RetroPistolItem;
   doColorShift = true;
   colorShiftColor = RetroPistolItem.colorShiftColor;

   TT_raycastDirectDamageType = $DamageType::RetroL4Pistol;

   stateSequence[4] = "eject";

   stateSequence[11] = "eject";
};

function RetroPistolImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0018;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0009;
		%this.TT_raycastWeaponRange = 200;
	}
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
}

function RetroPistolImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function RetroPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function RetroPistolImage::onBounce(%this,%obj,%slot)
{	
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function RetroPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, pistolClickSound, plant);
	%this.TT_displayAmmo(%obj);
}