AddDamageType("Scattergun",   '<bitmap:add-ons/Weapon_Skins_Shotgun/CI_Scattergun> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Shotgun/CI_Scattergun> %1',0.75,1);
datablock ProjectileData(ScattergunProjectile : PumpShotgunProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 7; //14
   directDamageType    = $DamageType::Scattergun;
   radiusDamageType    = $DamageType::Scattergun;
};

datablock ProjectileData(ScattergunBlastProjectile : ShotgunBlastProjectile)
{
   directDamageType    = $DamageType::Scattergun;
   radiusDamageType    = $DamageType::Scattergun;
};

//////////
// item //
//////////
datablock ItemData(ScattergunItem : PumpShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	 // Basic Item Properties
	shapeFile = "./Scattergun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	//gui stuff
	uiName = "Scattergun";
	iconName = "./icon_Scattergun";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.33 1";
	 // Dynamic properties defined by the scripts
	image = ScattergunImage;
	canDrop = true;
	TT_ammoType = "shotgun";
	TT_reloads = true;
	TT_maxAmmo = 7;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ScattergunImage : PumpShotgunImage)
{
   // Basic Item properties
	shapeFile = "./Scattergun.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = ScattergunItem;
   ammo = " ";
   projectile = ScattergunProjectile;
   projectileType = Projectile;
   casing = PumpShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   doColorShift = true;
   colorShiftColor = ScattergunItem.colorShiftColor;
};

function ScattergunImage::onFire(%this,%obj,%slot)
{
	if(%this.TT_canFire(%obj))
	{
		serverPlay3D(PumpShotgunfireSound,%obj.getPosition());
		%obj.playThread(2, activate);

		%this.TT_decrementAmmo(%obj);

		if($Pref::Server::TT::Recoil)
			%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

		%projectile = %this.projectile;
		%spread = 0.0042;
		%shellCount = 12;

		%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

		//just the muzzleflash
		//
		//nothing really special about this
		///////////////////////////////////////////////////////////
	
		// doesn't actually show up
		//TT_createProjectile(%this, %obj, %slot, shotgunFlashProjectile, 1);

		//shotgun blast projectile: only effective at point blank, sends targets flying off into the distance
		//
		//more or less represents the concussion blast. i can only assume such a thing exists because
		// i've never stood infront of a fucking shotgun before
		///////////////////////////////////////////////////////////
	
		TT_createProjectile(%this, %obj, %slot, ScattergunBlastProjectile, 1);
	}
	else if(!$Pref::Server::TT::DeathStopFiring || %obj.getDamagePercent() < 1.0)
	{
		serverPlay3D(PumpShotgunJamSound,%obj.getPosition());
	}
	%this.TT_displayAmmo(%obj);
	return %p;
}

function ScattergunImage::onEject(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%this.TT_displayAmmo(%obj);
}

function ScattergunImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftto);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function ScattergunImage::onReloaded(%this,%obj,%slot)
{
	%this.TT_incrementReload(%obj, %slot);
	%this.TT_displayAmmo(%obj);
}