//audio
// old T+T1 magnum fire sound
datablock AudioProfile(ScopedMagnumFireSound)
{
   filename    = "./magnum_fire.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("ScopedMagnum",   '<bitmap:base/client/ui/CI/generic> %1',    '%2 <bitmap:base/client/ui/CI/generic> %1',0.75,1);
//AddDamageType("ScopedMagnum",   '<bitmap:add-ons/Weapon_Package_Tier2A/CI_ScopedMagnum> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2A/CI_ScopedMagnum> %1',0.75,1);
datablock ProjectileData(ScopedMagnumProjectile)
{
   projectileShapeName = "add-ons/Vehicle_Tank/tankbullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::ScopedMagnum;
   radiusDamageType    = $DamageType::ScopedMagnum;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 14;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 22;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1800;
   verticalImpulse	  = 800;
   explosion           = ShotgunExplosion;
   particleEmitter     = MagnumTrailEmitter;

   muzzleVelocity      = 180;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 8000;
   fadeDelay           = 7200;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(ScopedMagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Scoped_Magnum_.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Scoped Magnum";
	iconName = "./iconScopedMagnum";
	doColorShift = true;
	colorShiftColor = "0.7 0.7 0.75 1.000";

	 // Dynamic properties defined by the scripts
	image = ScopedMagnumImage;
	canDrop = true;

	TT_ammoType = "880";
	TT_reloads = true;
	TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ScopedMagnumImage)
{

   // Basic Item properties
   shapeFile = "./Scoped_Magnum_.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ScopedMagnumItem;
   ammo = " ";
   projectile = ScopedMagnumProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ScopedMagnumItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateSequence[0]		= "Activate";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1]	= "ManualReload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";
	// stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= ScopedMagnumFireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]            = 0.4;
	stateTransitionOnTimeout[3]     = "Wait";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.65;
	stateTransitionOnTimeout[4]	= "LoadCheckA";

	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "TT_onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";

	stateName[6]				= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "Ready";
	stateTransitionOnNotLoaded[6]		= "Empty";

	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "ReloadStart";

	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 0.6;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Reloaded";
	// stateSound[8]				= Block_MoveBrick_Sound;

	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";
	// stateSound[9]				= Block_MoveBrick_Sound;

	stateName[10]                   = "Empty";
	stateTransitionOnLoaded[10]      = "Ready";
	stateTransitionOnAmmo[10]  = "ReloadWait";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                   = "EmptyFire";
	stateScript[11]                 = "TT_onEmptyFire";
	stateTransitionOnLoaded[11]      = "Ready";
	stateTransitionOnAmmo[11]           = "ReloadWait";
	stateTransitionOnTriggerUp[11]    = "Empty";

	stateName[12]                   = "ManualReload";
	stateTransitionOnAmmo[12]  = "ReloadWait";
	stateTransitionOnNoAmmo[12]     = "ReloadStart";

	stateName[13]                    = "FireCheckA";
	stateScript[13]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[13]     = "FireCheckB";

	stateName[14]                    = "FireCheckB";
	stateTransitionOnLoaded[14]   = "Fire";
	stateTransitionOnNotLoaded[14]      = "EmptyFire";
};

function ScopedMagnumImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, activate);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	// used to be a recoilless T+T1 gun. yep, those were the good ol' days...
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%spread = 0.0001;
	}
	else
	{
		%spread = 0;
	}
	%shellCount = 1;

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ScopedMagnumImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftDown);
	if(%obj.getDamagePercent() >= 1.0)
		%tslot = 0;
	else
		%tslot = 3;
	%obj.playThread(%tslot, plant);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ScopedMagnumImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	if(%obj.getDamagePercent() >= 1.0)
		%tslot = 0;
	else
		%tslot = 3;
	%obj.playThread(%tslot, shiftLeft);
	%this.TT_reload(%obj, %slot, block_PlantBrick_Sound, plant);
	%this.TT_displayAmmo(%obj);
}

//needs more critical headshots. the ScopedMagnum feels like a posing pistol right now :(
//using a weird offshoot of the huntsman's code for the moment
function ScopedMagnumProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 2, $DamageType::ScopedMagnum);
}