AddDamageType("ScoutARifle",   '<bitmap:add-ons/Weapon_Skins_RiflesT2/CI_scout_rifle> %1',    '%2 <bitmap:add-ons/Weapon_Skins_RiflesT2/CI_scout_rifle> %1',0.75,1);
datablock ProjectileData(ScoutTAssaultRifleProjectile1 : TAssaultRifleProjectile1)
{
   directDamage        = 14;
   directDamageType    = $DamageType::ScoutARifle;
   radiusDamageType    = $DamageType::ScoutARifle;
};

datablock ProjectileData(ScoutTAssaultRifleProjectile2 : TAssaultRifleProjectile2)
{
   directDamage        = 30;
   directDamageType    = $DamageType::ScoutARifle;
   radiusDamageType    = $DamageType::ScoutARifle;
};

datablock ItemData(ScoutTAssaultRifleItem : TAssaultRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Scout_AR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Scout A.Rifle";
	iconName = "./scoutassaultrifle";
	doColorShift = true;
	colorShiftColor = "0.39 0.36 0.3 1.000";

	 // Dynamic properties defined by the scripts
	image = ScoutTAssaultRifleImage;
	canDrop = true;

	TT_ammoType = "556";
	TT_reloads = true;
	TT_maxAmmo = 25;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ScoutTAssaultRifleImage : TAssaultRifleImage)
{
   shapeFile = "./Scout_AR.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = ScoutTAssaultRifleItem;
   ammo = " ";
   projectile = ScoutTAssaultRifleProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ScoutTAssaultRifleItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
};

function ScoutTAssaultRifleImage::onFire(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.1 && (getSimTime() - %obj.lastShotTime) > 500)
	{
		%projectile = ScoutTAssaultRifleProjectile2;
		%spread = 0.0001;
	}
	else
	{
		%projectile = %this.projectile;
		%spread = 0.0006;
	}
	%shellCount = 1;

	serverPlay3D(TAssaultRifleFire1Sound,%obj.getPosition());
	// TAssaultRifleFire2Sound doesn't exist
	// %sound = getRandom(1,2);
	// switch(%sound)
	// {
	// 	case 1:
	//             serverPlay3D(TAssaultRifleFire1Sound,%obj.getPosition());
	// 	case 2:
	//             serverPlay3D(TAssaultRifleFire2Sound,%obj.getPosition());
	// 	default:
	// 		echo("Invalid Sound");
	// }
	
	%obj.lastShotTime = getSimTime();
	
	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ScoutTAssaultRifleImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function ScoutTAssaultRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function ScoutTAssaultRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}
