AddDamageType("SemiBRifle",   '<bitmap:add-ons/Weapon_Package_Tier2/ci_brifle> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2/ci_brifle> %1',0.75,1);
datablock ProjectileData(SemiBattleRifleProjectile1 : BattleRifleProjectile1)
{
   directDamage        = 17;
   directDamageType    = $DamageType::SemiBRifle;
   radiusDamageType    = $DamageType::SemiBRifle;
};

datablock ItemData(SemiBattleRifleItem : BattleRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Semi_BR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Compact B.Rifle";
	iconName = "./icon_rifle_b";
	doColorShift = true;
	colorShiftColor = "0.49 0.49 0.52 1.000";

	 // Dynamic properties defined by the scripts
	image = SemiBattleRifleImage;
	canDrop = true;

	TT_ammoType = "708";
	TT_reloads = true;
	TT_maxAmmo = 22;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SemiBattleRifleImage : BattleRifleImage)
{
   // Basic Item properties
   shapeFile = "./Semi_BR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SemiBattleRifleItem;
   ammo = " ";
   projectile = SemiBattleRifleProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = SemiBattleRifleItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
};

function SemiBattleRifleImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0022;
	}
	else
	{
		%spread = 0.0044;
	}
	%shellCount = 1;

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function SemiBattleRifleImage::onReloadStart(%this,%obj,%slot)
{           		
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftright);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function SemiBattleRifleImage::onReloading(%this,%obj,%slot)
{           		
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function SemiBattleRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function SemiBattleRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function BattlerifleProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.2);
   }
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}
