//////////
// item //
//////////
datablock ItemData(AkimboSilencedPistolItem : SilencedPistolItem)
{
	uiName = "Covert Pistols A.";
   	shapeFile = "add-ons/weapon_skins_pistol/pistol_covert.dts";
	iconName = "./item_dualSilenced";
	colorShiftColor = Silencedpistolitem.colorshiftcolor;
	 // Dynamic properties defined by the scripts
	image = AkimboSilencedPistolImage;
	//Ammo Guns Parameters
	l4ditemtype = "secondary";
	TT_maxAmmo = Silencedpistolitem.TT_maxAmmo*2;
};

////////////////
//weapon image//
////////////////
AddDamageType("AkimboL4SilencedPistol",   '<bitmap:add-ons/Weapon_Package_Tier1/CI_DualPistol> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier1/CI_DualPistol> %1',0.75,1);
datablock ShapeBaseImageData(AkimboSilencedPistolImage : AkimboPistolImage)
{
   // Basic Item properties
   	shapeFile = "add-ons/weapon_skins_pistol/pistol_covert.dts";
   item = AkimboSilencedPistolItem;

   doColorShift = true;
   colorShiftColor = AkimboSilencedPistolItem.colorShiftColor;//"0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   TT_raycastEnabled = true;
   TT_raycastWeaponRange = 200; //varies
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = GunProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastDirectDamage = Silencedpistolimage.TT_raycastdirectdamage;
   TT_raycastDirectDamageType = $DamageType::AkimboL4SilencedPistol;
   TT_raycastSpreadAmt = 0.0006; //varies
   TT_raycastSpreadCount = 1;
   TT_raycastTracerProjectile = PistolTracerProjectile;
   TT_raycastFromMuzzle = true;

	stateSound[2]			  = SilencedPistolfireSound;

};

datablock ShapeBaseImageData(LeftHandedSilencedPistolImage : LeftHandedPistolImage)
{
   // Basic Item properties
   	shapeFile = "add-ons/weapon_skins_pistol/pistol_covert.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = AkimboSilencedPistolItem;
   ammo = " ";
   projectile = PumpShotgunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = true;
   colorShiftColor = AkimboSilencedPistolItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   TT_raycastEnabled = true;
   TT_raycastWeaponRange = 200; //varies
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = GunProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastDirectDamage = Silencedpistolimage.TT_raycastdirectdamage;
   TT_raycastDirectDamageType = $DamageType::AkimboL4SilencedPistol;
   TT_raycastSpreadAmt = 0.0006; //varies
   TT_raycastSpreadCount = 1;
   TT_raycastTracerProjectile = PistolTracerProjectile;
   TT_raycastFromMuzzle = true;

	stateSound[2]			  = SilencedPistolfireSound;
};

function AkimboSilencedPistolImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.mountImage(LeftHandedSilencedPistolImage, 1);
}

function AkimboSilencedPistolImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
	%obj.unMountImage(1);
}

function AkimboSilencedPistolImage::onFire(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0018;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0006;
		%this.TT_raycastWeaponRange = 200;
	}
	
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
}

function AkimboSilencedPistolImage::onFireAkimbo(%this,%obj,%slot)
{
	%obj.setImageTrigger(1,1);
	if($Pref::Server::TT::DeathStopFiring)
		%obj.setImageTrigger(1,0);
	%this.TT_displayAmmo(%obj);
}

function AkimboSilencedPistolImage::onLoadCheck(%this,%obj,%slot)
{
	Parent::onLoadCheck(%this,%obj,%slot);
	%obj.setImageAmmo(1,%obj.getImageAmmo(0));
}

function AkimboSilencedPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, activate2);
	serverPlay3D(block_moveBrick_Sound,%obj.getPosition());
}

//function AkimboSilencedPistolImage::onReloadLeft(%this,%obj,%slot)
//{
//	%obj.playThread(3, leftRecoil);
//}

function AkimboSilencedPistolImage::onReloadNext(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(block_plantBrick_Sound,%obj.getPosition());
}

function AkimboSilencedPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, pistolClickSound, plant);
	%this.TT_displayAmmo(%obj);
}

function LeftHandedSilencedPistolImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, armreadyboth);
}

function LeftHandedSilencedPistolImage::onFire(%this, %obj, %slot)
{
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0027;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0012;
		%this.TT_raycastWeaponRange = 200;
	}
	
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, leftrecoil);
}