datablock AudioProfile(SilencedPistolFireSound)
{
   filename    = "./silpistol.wav";
   description = AudioClose3d;
   preload = true;
};

//////////
// item //
//////////
datablock ItemData(SilencedPistolItem : PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./pistol_covert.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Covert Pistol";
	iconName = "./covertpistol";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1.000";
	l4ditemtype = "secondary";

	 // Dynamic properties defined by the scripts
	image = SilencedPistolImage;
	canDrop = true;

	TT_ammoType = "9MM";
	TT_reloads = true;
	TT_maxAmmo = 14;
};

////////////////
//weapon image//
////////////////
AddDamageType("SilencedL4Pistol",   '<bitmap:add-ons/Weapon_Skins_Pistol/ci_silenced_pistol> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Pistol/ci_silenced_pistol> %1',0.75,1);
datablock ShapeBaseImageData(SilencedPistolImage : PistolImage)
{
   TT_raycastDirectDamage = 9;

   shapeFile = "./pistol_covert.dts";
   // Projectile && Ammo.
   item = SilencedPistolItem;
   doColorShift = true;
   colorShiftColor = SilencedPistolItem.colorShiftColor;

   TT_raycastDirectDamageType = $DamageType::SilencedL4Pistol;

	stateSound[4]			= silencedPistolfireSound;
};

function SilencedPistolImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.TT_raycastSpreadAmt = 0.0022;
		%this.TT_raycastWeaponRange = 85;
	}
	else
	{
		%this.TT_raycastSpreadAmt = 0.0001;
		%this.TT_raycastWeaponRange = 200;
	}
	
	Parent::onFire(%this,%obj,%slot);
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftAway);
}

function SilencedPistolImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftUp);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function SilencedPistolImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function SilencedPistolImage::onBounce(%this,%obj,%slot)
{	
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function SilencedPistolImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, pistolClickSound, plant);
	%this.TT_displayAmmo(%obj);
}