AddDamageType("TacticalBullpup",   '<bitmap:add-ons/Weapon_Skins_Bullpup/CI_2> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Bullpup/CI_2> %1',0.75,1);
datablock ProjectileData(TacticalBullpupProjectile1 : BullpupProjectile1)
{
   directDamage        = 17; //22 // Before it used original bullpup projectile so damage should be same
   directDamageType    = $DamageType::TacticalBullpup;
   radiusDamageType    = $DamageType::TacticalBullpup;
};

datablock ItemData(TacticalBullpupItem : BullpupItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./bullpup_tactical.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Tactical Bullpup";
	iconName = "./tacticalbullpup";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.34 1.000";

	 // Dynamic properties defined by the scripts
	image = TacticalBullpupImage;
	canDrop = true;
	
   TT_ammoType = "556";
   TT_reloads = true;
   TT_maxAmmo = 21;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TacticalBullpupImage : BullpupImage)
{
	shapeFile = "./bullpup_tactical.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = TacticalBullpupItem;
   ammo = " ";
   projectile = TacticalBullpupProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = TacticalBullpupItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
};

function TacticalBullpupImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0002;
	}
	else
	{
		%spread = 0.0004;
	}
	%shellCount = 1;

	%obj.lastShotTime = getSimTime();

	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

	%this.TT_displayAmmo(%obj);
	return %p;
}

function TacticalBullpupImage::onBurstFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   if(vectorLen(%obj.getVelocity()) < 0.1)
   {
      %spread = 0.0002;
   }
   else
   {
      %spread = 0.0004;
   }
   %shellCount = 1;

   %obj.lastShotTime = getSimTime();

   %obj.playThread(2, plant);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

   %p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

   return %p;
}

function TacticalBullpupImage::onBurstCheck(%this, %obj, %slot)
{
   if(%this.TT_canFire(%obj))
   {
      %obj.setImageLoaded(%slot, 1);
      %this.TT_decrementAmmo(%obj);
      %this.TT_displayAmmo(%obj);
   }
   else
   {
      %obj.setImageLoaded(%slot, 0);
   }
}

function TacticalBullpupImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function TacticalBullpupImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound,%obj.getPosition());
}

function TacticalBullpupImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}
