AddDamageType("SquaredShotgun",   '<bitmap:add-ons/Weapon_Skins_Shotgun/CI_modern_shotgun> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Shotgun/CI_modern_shotgun> %1',0.75,1);
datablock ProjectileData(SquaredshotgunProjectile : PumpShotgunProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 9-2; //14;
   directDamageType    = $DamageType::SquaredShotgun;
   radiusDamageType    = $DamageType::SquaredShotgun;
};

datablock ProjectileData(SquaredshotgunBlastProjectile : ShotgunBlastProjectile)
{
   directDamageType    = $DamageType::SquaredShotgun;
   radiusDamageType    = $DamageType::SquaredShotgun;
};

//////////
// item //
//////////
datablock ItemData(SquaredShotgunItem : PumpShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	 // Basic Item Properties
	shapeFile = "./Spas_Shotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	//gui stuff
	uiName = "Modern Shotgun";
	iconName = "./modernshotgun";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	 // Dynamic properties defined by the scripts
	image = SquaredShotgunImage;
	canDrop = true;
	TT_ammoType = "shotgun";
	TT_reloads = true;
	TT_maxAmmo = 7;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SquaredShotgunImage : PumpShotgunImage)
{
   // Basic Item properties
   shapeFile = "./Spas_Shotgun.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = SquaredShotgunItem;
   ammo = " ";
   projectile = SquaredshotgunProjectile;
   projectileType = Projectile;
   casing = PumpShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   doColorShift = true;
   colorShiftColor = SquaredShotgunItem.colorShiftColor;

   stateSequence[4] = "pump";
   stateSequence[12] = "pump";
};

function SquaredShotgunImage::onFire(%this,%obj,%slot)
{
	if(%this.TT_canFire(%obj))
	{
		serverPlay3D(PumpShotgunfireSound,%obj.getPosition());
		%obj.playThread(2, activate);

		%this.TT_decrementAmmo(%obj);

		if($Pref::Server::TT::Recoil)
			%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

		%projectile = %this.projectile;
		%spread = 0.0032;
		%shellCount = 9;

		%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

		//just the muzzleflash
		//
		//nothing really special about this
		///////////////////////////////////////////////////////////
	
		// doesn't actually show up
		//TT_createProjectile(%this, %obj, %slot, shotgunFlashProjectile, 1);

		//shotgun blast projectile: only effective at point blank, sends targets flying off into the distance
		//
		//more or less represents the concussion blast. i can only assume such a thing exists because
		// i've never stood infront of a fucking shotgun before
		///////////////////////////////////////////////////////////
	
		TT_createProjectile(%this, %obj, %slot, SquaredShotgunBlastProjectile, 1);
	}
	else if(!$Pref::Server::TT::DeathStopFiring || %obj.getDamagePercent() < 1.0)
	{
		serverPlay3D(PumpShotgunJamSound,%obj.getPosition());
	}
	%this.TT_displayAmmo(%obj);
	return %p;
}

function SquaredShotgunImage::onEject(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%this.TT_displayAmmo(%obj);
}

function SquaredShotgunImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftto);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function SquaredShotgunImage::onReloaded(%this,%obj,%slot)
{
	%this.TT_incrementReload(%obj, %slot);
	%this.TT_displayAmmo(%obj);
}