datablock AudioProfile(tierfragGrenadeExplosionSound)
{
   filename    = "./grenade_explode.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(tierfragGrenadeTossSound)
{
   filename    = "./grenade_toss.wav";
   description = AudioClosest3d;
   preload = true;
};

////////////////////////////////////

datablock ParticleData(tierstickgrenadeTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.4 0.4 0.3 0.0";
	colors[1]	= "0.4 0.4 0.3 0.1";
	colors[2]	= "0.4 0.4 0.3 0.0";
	sizes[0]	= 0.7;
	sizes[1]	= 0.2;
	sizes[2]	= 0.1;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(tierstickgrenadeTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 2;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = tierstickgrenadeTrailParticle;
};

datablock ParticleData(tierstickGrenadeExplosionParticle)
{
	dragCoefficient		= 3.5;
	windCoefficient		= 3.5;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1900;
	lifetimeVarianceMS	= 900;
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "1 1 1 0.1";
   colors[1]     = "0.9 0.5 0.0 0.9";
   colors[2]     = "0.1 0.05 0.025 0.1";
   colors[3]     = "0.1 0.05 0.025 0.0";

	sizes[0]	= 5.0;
	sizes[1]	= 4.3;
   sizes[2]	= 4.5;
   sizes[3]	= 6.5;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 0.8;
   times[3]	= 1.0;
};

datablock ParticleEmitterData(tierstickGrenadeExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifeTimeMS	   = 81;
   ejectionVelocity = 40;
   velocityVariance = 10.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0; //-30
   thetaMax         = 30;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierstickGrenadeExplosionParticle";
};

datablock ParticleData(tierstickGrenadeExplosionParticle2)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 1990;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
   colors[0]     = "1 0.5 0.0 1";
   colors[1]     = "0.9 0.5 0.0 0.9";
   colors[2]     = "1 1 1 0.0";

	sizes[0]	= 0.3;
	sizes[1]	= 0.3;
   sizes[2]	= 0.3;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(tierstickGrenadeExplosionEmitter2)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   lifetimeMS       = 120;
   ejectionVelocity = 12;
   velocityVariance = 12.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierstickGrenadeExplosionParticle2";
};


datablock ParticleData(tierstickGrenadeExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed        = 0.0;
   spinRandomMin        = 0.0;
   spinRandomMax        = 0.0;
   colors[0]     = "1.0 1.0 1 1";
   colors[1]     = "0.9 0.5 0.0 0.9";
   sizes[0]      = 18;
   sizes[1]      = 7;

   useInvAlpha = false;
};

datablock ParticleEmitterData(tierstickGrenadeExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 20;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierstickGrenadeExplosionRingParticle";
};

datablock ParticleData(tierstickGrenadeExplosionRing2Particle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = 0;
	windCoefficient		= 9.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 2350;
	lifetimeVarianceMS   = 135;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
   colors[0]     = "1 1 1 0.1";
   colors[1]     = "0.9 0.5 0.0 0.4";
   colors[2]     = "0.9 0.5 0.0 0.1";
   colors[3]     = "0.1 0.05 0.025 0.0";

	sizes[0]	= 5.0;
	sizes[1]	= 4.3;
   sizes[2]	= 4.5;
   sizes[3]	= 3.5;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 0.8;
   times[3]	= 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(tierstickGrenadeExplosionRing2Emitter)
{
	lifeTimeMS = 90;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 25;
   velocityVariance = 2.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierstickGrenadeExplosionRing2Particle";
};

datablock ParticleData(tierstickGrenadeExplosionHazeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0;
	windCoefficient		= 9.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 2700;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
   	colors[0]     = "0.7 0.4 0.0 0.8";
   	colors[1]     = "0.4 0.15 0.025 0.1";
   	colors[2]     = "0.1 0.05 0.025 0.0";
	times[0]	= 0.0;
	times[1]	= 0.1;
   	times[2]	= 1.0;
	sizes[0]      = 3.0;
	sizes[1]      = 3.85;
	sizes[2]      = 4.35;

	useInvAlpha = true;
};
datablock ParticleEmitterData(tierstickGrenadeExplosionHazeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 25;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierstickGrenadeExplosionHazeParticle";

   useEmitterColors = true;
};

datablock ParticleData(tierstickGrenadeExplosionCloudParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2800;
	lifetimeVarianceMS	= 00;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.9 0.5 0.0 0.4";
   colors[1]     = "0.1 0.05 0.025 0.0";
	sizes[0]      = 8;
	sizes[1]      = 6;
};

datablock ParticleEmitterData(tierstickGrenadeExplosionCloudEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   lifeTimeMS	   = 90;
   ejectionVelocity = 98;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "tierstickGrenadeExplosionCloudParticle";
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

datablock ExplosionData(stickgrenadesubExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(tierstickGrenadeExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = tierFragGrenadeExplosionSound;
   
   emitter[0] = tierstickGrenadeExplosionRingEmitter;
   emitter[1] = tierstickGrenadeExplosionEmitter;
   emitter[2] = tierstickGrenadeExplosionRing2Emitter;
   emitter[3] = tierstickGrenadeExplosionHazeEmitter;
   emitter[4] = tierstickGrenadeExplosionCloudEmitter;
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";

   subExplosion[0] = stickgrenadeSubExplosion;

   particleEmitter = tierstickGrenadeExplosionEmitter2;
   particleDensity = 90;
//   particleDensity = 0;
   particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 9;
   impulseForce = 5600;

   damageRadius = 6;
   radiusDamage = 290;

   uiName = "Tall Grenade Explosion";
};

// datablock ParticleEmitterData(stickExplosionEmitter)
// {
//    ejectionPeriodMS = 5;
//    periodVarianceMS = 0;
//    ejectionVelocity = 4;
//    velocityVariance = 0.0;
//    ejectionOffset   = 0.0;
//    thetaMin         = 89;
//    thetaMax         = 90;
//    phiReferenceVel  = 0;
//    phiVariance      = 360;
//    overrideAdvance = false;
//    particles = "stickExplosionParticle";

//    useEmitterColors = true;
// };

// datablock ExplosionData(stickExplosion)
// {
//    //explosionShape = "";
// 	soundProfile = "";

//    lifeTimeMS = 500; // 50

//    emitter[0] = stickExplosionEmitter;

//    faceViewer     = true;
//    explosionScale = "1 1 1";

//    shakeCamera = false;
//    camShakeFreq = "10.0 11.0 10.0";
//    camShakeAmp = "1.0 1.0 1.0";
//    camShakeDuration = 0.5;
//    camShakeRadius = 10.0;

//    // Dynamic light
//    lightStartRadius = 0;
//    lightEndRadius = 1;
//    lightStartColor = "0.3 0.6 0.7";
//    lightEndColor = "0 0 0";
// };

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

AddDamageType("TstickgrenadeDirect",   '<bitmap:add-ons/weapon_package_explosive1/ci_stick_grenade> %1',    '%2 <bitmap:add-ons/weapon_package_explosive1/ci_stick_grenade> %1',1,1);

//projectile
datablock ProjectileData(tierstickGrenadeProjectile)
{
   projectileShapeName = "./stick_grenade.2.dts";
   directDamage        = 10;
   directDamageType  = $DamageType::TstickGrenadeDirect;
   radiusDamageType  = $DamageType::TstickGrenadeDirect;
   impactImpulse	   = 1200;
   verticalImpulse	   = 1200;
   explosion           = tierstickGrenadeExplosion;
   particleEmitter     = tierstickGrenadeTrailEmitter;

   muzzleVelocity      = 35;
   velInheritFactor    = 0;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   // stickExplosion        = stickExplosion; // doesn't show up
   brickExplosionRadius = 5;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 34;             
   brickExplosionMaxVolume = 45;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 90;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   armingDelay         = 3990; 
   lifetime            = 4000;
   bounceAngle         = 120; //stick almost all the time
   minStickVelocity    = 10;
   fadeDelay           = 3999;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Stick Grenade";
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////
// item //
//////////
datablock ItemData(tierstickGrenadeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./stick_grenade.1.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	l4ditemtype = "grenade";

	//gui stuff
	uiName = "Stick Grenade";
	iconName = "./icon_stick_grenade";

	 // Dynamic properties defined by the scripts
	image = tierstickGrenadeImage;
	canDrop = true;

   TT_ammoType = "stickNades";
   TT_grenade = true;
};

datablock ShapeBaseImageData(tierstickGrenadeImage)
{
   // Basic Item properties
   shapeFile = "./stick_grenade.1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tierstickGrenadeItem;
   ammo = " ";
   projectile = tierstickGrenadeProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.01;
	stateTransitionOnTimeout[0]	= "Ready";
	// stateScript[0]                  = "onActivate";

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Tick";
	stateScript[1]                  = "onReady";
	// stateTransitionOnTimeout[1]	= "Ready";
	// stateWaitForTimeout[1]		= false;
	// stateTimeoutValue[1]		= 0.4;
	// stateAllowImageChange[1]	= true;

	stateName[2]			= "Tick";
	stateTransitionOnTimeout[2]	= "Charge";
	stateAllowImageChange[2]	= false;
	stateSound[2]				= block_moveBrick_Sound;
	stateScript[2]                  = "onPull";
	stateTimeoutValue[2]		= 0.05;

	// stateName[3]			= "SKIPC";
	// stateTransitionOnTriggerDown[3]	= "Charge";
	// stateAllowImageChange[3]	= false;
	
	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]	= "Armed";
	stateTimeoutValue[3]            = 0.1;
	// stateWaitForTimeout[3]		= false;
	stateScript[3]                  = "onCharge";
	// stateAllowImageChange[3]        = true;
	
	// stateName[5]			= "AbortCharge";
	// stateTransitionOnTimeout[5]	= "Ready";
	// stateTimeoutValue[5]		= 0.1;
	// stateWaitForTimeout[5]		= true;
	// stateScript[5]			= "onAbortCharge";
	// stateAllowImageChange[5]	= false;

	stateName[4]			= "Armed";
	stateScript[4]			= "onArmed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	// stateWaitForTimeout[4]		= false;
	// stateTimeoutValue[4]		= 0.4;
	// stateAllowImageChange[4]	= true;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Activate";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	// stateSound[5]				= tierfraggrenadetossSound;
	// stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	// stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;

	// stateName[8]					= "Done";
	// stateScript[8]					= "onDone";
	// stateTransitionOnTimeout[8]	= "Activate";
	// stateTimeoutValue[8]		= 0.5;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function tierstickGrenadeImage::onArmed(%this, %obj, %slot)
{
   %this.TT_displayAmmo(%obj, 0);
   %obj.playthread(2, spearready);
   // This flag will allow the image to fire even after death, but isn't set if Armed state is not held
   %obj.setImageAmmo(0, 0);
	// %obj.lasttierstickslot = %obj.currTool;
}

// function tierstickGrenadeImage::onAbortCharge(%this, %obj, %slot)
// {
// 		%obj.playThread(2, plant);
//     	if(%obj.client.quantity["stickNades"] <= 0 && %obj.getClassName() !$= "AIPlayer")
// 	{
// 	%obj.unMountImage(0);
// 	%obj.playThread(1, root);
// 	}
// }

function tierstickGrenadeImage::onFire(%this, %obj, %slot)
{
   if((%obj.getDamagePercent() < 1.0 || !%obj.getImageAmmo(0)) && !%this.TT_needsAmmo(%obj))
   {
      %p = Parent::onFire(%this, %obj, %slot);
      %this.TT_decrementAmmo(%obj);
      %obj.playThread(2, spearthrow);
      serverPlay3D(tierfraggrenadetossSound,%obj.getPosition());
      serverPlay3D(tierfraggrenadetossSound,%obj.getPosition());
   }

   if(%this.TT_needsAmmo(%obj))
   {
      %obj.unMountImage(0);
   }
   %this.TT_displayAmmo(%obj, 1);
   %obj.setImageAmmo(0, 1);
   return %p;
}

function tierstickGrenadeImage::onReady(%this, %obj, %slot)
{
   %this.TT_displayAmmo(%obj, 0);
   if(%this.TT_needsAmmo(%obj))
   {
      %obj.unMountImage(0);
      // %obj.playThread(2, root);
      %obj.playThread(1, root);
      // %obj.playThread(0, root);
      %this.TT_displayAmmo(%obj, 1);
   }
}

function tierstickGrenadeImage::onPull(%this, %obj, %slot)
{
   %this.TT_displayAmmo(%obj, 0);
   if(%this.TT_needsAmmo(%obj))
   {
      %obj.unMountImage(0);
      // %obj.playThread(2, root);
      %obj.playThread(1, root);
      // %obj.playThread(0, root);
      %this.TT_displayAmmo(%obj, 1);
   }
   else
   {
      %obj.playThread(2, shiftRight);
   }
}

function tierstickGrenadeImage::onCharge(%this, %obj, %slot)
{
   if(%this.TT_needsAmmo(%obj))
   {
      %obj.unMountImage(0);
      // %obj.playThread(2, root);
      %obj.playThread(1, root);
      // %obj.playThread(0, root);
      %this.TT_displayAmmo(%obj, 1);
   }
}