return; // you know what to do, don't you?

datablock AudioProfile(TTOSKFireSound)
{
   filename    = "./osk_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TTOSKImpactSound)
{
   filename    = "./osk_BOOM.wav";
   description = AudioClose3d;
   preload = true;
};


datablock ParticleData(TTOSKTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;

	textureName		= "base/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 0.0 0.5";
	colors[1]	= "1 1 0.5 0.25";
	colors[2]	= "1 1 1 0";
	sizes[0]	= 1;
	sizes[1]	= 0.5;
	sizes[2]	= 0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(TTOSKTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;

   ejectionVelocity = -20; //0.25;
   velocityVariance = 5;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 15.0;

   phiReferenceVel = 360;
   phiVariance = 360;

   particles = "TTOSKTrailParticle";

   useEmitterColors = true;
};

datablock ExplosionData(TTOSKImpactExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   particleEmitter = shotgunExplosionRingEmitter;
   particleDensity = 5;
   particleRadius = 0.5;

   emitter[0] = TTOSKTrailEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;
};

datablock ParticleData(TTOSKSpiralParticle : TTOSKTrailParticle)
{
	lifetimeMS		= 1000;

	sizes[0]	= 0.25;
	sizes[1]	= 0.15;
	sizes[2]	= 0.15;
};

datablock ParticleEmitterData(TTOSKSpiralEmitter : TTOSKTrailEmitter)
{
   ejectionVelocity = -30; //0.25;
   velocityVariance = 1;

   thetaMin         = 14.0;

   phiReferenceVel = 1400;
   phiVariance = 0;

   particles = "TTOSKSpiralParticle";
};

datablock ParticleData(TTOSKStarParticle : TTOSKTrailParticle)
{
	dragCoefficient		= 7.0;
	lifetimeMS		= 1000;

	textureName		= "base/data/particles/star1";

	colors[0]	= "1 1 1 0.5";
	colors[1]	= "1 1 1 0.25";
};

datablock ParticleEmitterData(TTOSKStarEmitter : TTOSKTrailEmitter)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 50;

   ejectionOffset = 0.5;

   thetaMin         = 30.0;
   thetaMax         = 31.0;

   phiReferenceVel = 0;

   particles = "TTOSKStarParticle";
};

AddDamageType("TTOSK",   '<bitmap:add-ons/weapon_package_tier2a/ci_ttosk> %1',    '%2 <bitmap:add-ons/weapon_package_tier2a/ci_ttosk> %1',1,1);
datablock ProjectileData(TTOSKStarProjectile)
{
	directDamage        = 100;
	directDamageType    = $DamageType::TTOSK;
   radiusDamageType    = $DamageType::TTOSK;

   impactImpulse	     = 5000;
   verticalImpulse	  = 2000;

	particleEmitter = TTOSKStarEmitter;
	lifetime = 1000;
	armingDelay = 1000;
	fadeDelay = 1000;
	isBallistic = false;
};

datablock ProjectileData(TTOSKImpactProjectile : TTOSKStarProjectile)
{
	particleEmitter = TTOSKTrailEmitter;
	explosion = "TTOSKImpactExplosion";
	explodeOnDeath = true;
};

datablock ProjectileData(TTOSKSpiralProjectile : TTOSKStarProjectile)
{
	particleEmitter = TTOSKSpiralEmitter;
};

datablock ProjectileData(TTOSKProjectile)
{
   projectileShapeName = "add-ons/Vehicle_Tank/tankbullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::TTOSK;
   radiusDamageType    = $DamageType::TTOSK;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 100;
   brickExplosionMaxVolume = 655360;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 655360;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5000;
   verticalImpulse	  = 2000;
   explosion           = "";
   particleEmitter     = "TTOSKTrailEmitter";

   muzzleVelocity      = 65;
   velInheritFactor    = 1;

   armingDelay         = 8000;
   lifetime            = 8000;
   fadeDelay           = 8000;
   bounceElasticity    = 0;
   bounceFriction      = 1;
   isBallistic         = false;
   gravityMod = 0;
};

datablock ProjectileData(TTOSKBrickKillProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	lifetime = 100;
	armingDelay = 100;
	fadeDelay = 100;
	isBallistic = false;

	brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 100;
   brickExplosionMaxVolume = 655360;          //volume of a 64x cube
   brickExplosionMaxVolumeFloating = 655360;
};

//////////
// item //
//////////
datablock ItemData(TTOSKItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ttosk.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "One Shot Kill";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.34 0.37 0.51 1";

	 // Dynamic properties defined by the scripts
	image = TTOSKImage;
	canDrop = true;

	TT_ammoType = "880";
	TT_reloads = true;
	TT_maxAmmo = 1;
	TT_alwaysReloadPref = "NonEx";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TTOSKImage)
{
   // Basic Item properties
   shapeFile = "./ttosk.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TTOSKItem;
   ammo = " ";
   projectile = TTOSKProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = TTOSKItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateSequence[0]		= "Activate";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1]	= "ReloadWait";
	stateTransitionOnTriggerDown[1] = "FireCheckA";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateEmitter[2]			= shotgunExplosionRingEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= TTOSKFireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]            = 0.4;
	stateTransitionOnTimeout[3]     = "Wait";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.65;
	stateTransitionOnTimeout[4]	= "LoadCheckA";

	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "TT_onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";

	stateName[6]				= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "Ready";
	stateTransitionOnNotLoaded[6]		= "Empty";

	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "ReloadStart";

	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 0.6;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Reloaded";

	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";

	stateName[10]                   = "Empty";
	stateTransitionOnLoaded[10]      = "Ready";
	stateTransitionOnAmmo[10]  = "ReloadWait";
	stateTransitionOnTriggerDown[10]     = "FireCheckA";

	stateName[11]                   = "EmptyFire";
	stateScript[11]                 = "TT_onEmptyFire";
	stateTransitionOnLoaded[11]      = "Ready";
	stateTransitionOnAmmo[11]           = "ReloadWait";
	stateTransitionOnTriggerUp[11]    = "Empty";

	stateName[12]                    = "FireCheckA";
	stateScript[12]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[12]     = "FireCheckB";

	stateName[13]                    = "FireCheckB";
	stateTransitionOnLoaded[13]   = "Fire";
	stateTransitionOnNotLoaded[13]      = "EmptyFire";
};

function TTOSKImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, activate);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	// used to be a recoilless T+T1 gun. yep, those were the good ol' days...
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	return Parent::onFire(%this,%obj,%slot);

	// %projectile = %this.projectile;
	// %spread = 0;
	// %shellCount = 1;

	// return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function TTOSKImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftDown);
	if(%obj.getDamagePercent() >= 1.0)
		%tslot = 0;
	else
		%tslot = 3;
	%obj.playThread(%tslot, plant);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function TTOSKImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%obj.playThread(2, shiftLeft);
	%this.TT_reload(%obj, %slot, block_PlantBrick_Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function TTOSKProjectile::spawnProj(%this, %db, %vel, %pos, %srcObj, %client, %scale)
{
	%p = new Projectile()
	{
		dataBlock = %db;
		initialVelocity = %vel;
		initialPosition = %pos;
		sourceObject = %srcObj;
		client = %client;
	};
   %p.setScale(%scale SPC %scale SPC %scale);
	MissionCleanup.add(%p);
	return %p;
}

function TTOSKProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
	if(%col != %obj.lastCol)
	{
		%scale = getWord(%obj.getScale(), 2);
		%vel = %obj.initialVelocity;
		if(!%obj.firstPierceTime || getSimTime() - %obj.firstPierceTime < 30000)
			%this.schedule(1000, pierce, %vel, %pos, %obj.sourceObject, %obj.client, %col, %obj.firstPierceTime, %scale);
		%obj.schedule(0, delete);
		// Glittery special effects
		%this.spawnProj(TTOSKSpiralProjectile, VectorScale(%obj.initialVelocity, -0.04 / VectorLen(%obj.initialVelocity) / %scale), %pos, %obj.sourceObject, %obj.client, %scale);
		%this.spawnProj(TTOSKStarProjectile, VectorScale(%obj.initialVelocity, -0.04 / VectorLen(%obj.initialVelocity) / %scale), %pos, %obj.sourceObject, %obj.client, %scale);
		%this.spawnProj(TTOSKImpactProjectile, VectorScale(%obj.initialVelocity, -0.04 / VectorLen(%obj.initialVelocity) / %scale), %pos, %obj.sourceObject, %obj.client, %scale);
		serverPlay3D(TTOSKImpactSound,%pos);
	}
	return Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
}

function TTOSKProjectile::pierce(%this, %vel, %pos, %srcObj, %client, %lastCol, %firstPierceTime, %scale)
{
	if(%firstPierceTime $= "")
		%firstPierceTime = getSimTime();
	// Brick killing projectile
	%this.spawnProj(TTOSKBrickKillProjectile, VectorScale(%vel, 0.04 / VectorLen(%vel)), %pos, %srcObj, %client, 1);
	// Clone of original projectile goes on its merry way
	%p = %this.spawnProj(TTOSKProjectile, %vel, %pos, %srcObj, %client, %scale);
	%p.firstPierceTime = %firstPierceTime;
	%p.lastCol = %lastCol;
	return %p;
}

// *One shot kills not guaranteed.
function TTOSKProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
      %col.damage(%obj,%pos,%col.getDataBlock().maxDamage * 10,%this.directDamageType);
	}
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}

function TTOSKSpiralProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
      %col.damage(%obj,%pos,%col.getDataBlock().maxDamage * 10,%this.directDamageType);
	}
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}

function TTOSKImpactProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
      %col.damage(%obj,%pos,%col.getDataBlock().maxDamage * 10,%this.directDamageType);
	}
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}

function TTOSKStarProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
      %col.damage(%obj,%pos,%col.getDataBlock().maxDamage * 10,%this.directDamageType);
	}
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}
