AddDamageType("tacticalShotgun",   '<bitmap:add-ons/Weapon_Skins_ShotgunT2/CI_tactical_shotgun> %1',    '%2 <bitmap:add-ons/Weapon_Skins_ShotgunT2/CI_tactical_shotgun> %1',0.75,1);
datablock ProjectileData(TacticalShotgunProjectile : CombatShotgunProjectile)
{
   // projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamageType    = $DamageType::tacticalShotgun;
   radiusDamageType    = $DamageType::tacticalShotgun;
};

datablock ProjectileData(TacticalShotgunBlastProjectile : ShotgunBlastProjectile)
{
   directDamageType    = $DamageType::tacticalShotgun;
   radiusDamageType    = $DamageType::tacticalShotgun;
};

//////////
// item //
//////////
datablock ItemData(tacticalShotgunItem : CombatShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./tactical_Shotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Tactical Shotgun";
	iconName = "./icon_tactical_shotgun";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.51 1";

	 // Dynamic properties defined by the scripts
	image = tacticalShotgunImage;
	canDrop = true;

	TT_ammoType = "shotgun";
	TT_reloads = true;
	TT_maxAmmo = 7;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(tacticalShotgunImage : CombatShotgunImage)
{
   // Basic Item properties
   shapeFile = "./tactical_Shotgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tacticalShotgunItem;
   ammo = " ";
   projectile = tacticalShotgunProjectile;
   projectileType = Projectile;

   casing = PumpShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;

   doColorShift = true;
   colorShiftColor = tacticalShotgunItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
};

function tacticalShotgunImage::onFire(%this,%obj,%slot)
{
	if(%this.TT_canFire(%obj))
	{
		serverPlay3D(CombatShotgunfireSound,%obj.getPosition());
		%obj.playThread(2, activate);
		
		%this.TT_decrementAmmo(%obj);

		if($Pref::Server::TT::Recoil)
			%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

		%projectile = %this.projectile;
		%spread = 0.0027;
		%shellCount = 9;

		%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

		//just the muzzleflash
		//
		//nothing really special about this
		///////////////////////////////////////////////////////////

		// TT_createProjectile(%this, %obj, %slot, shotgunFlashProjectile, 1);
	
		//shotgun blast projectile: only effective at point blank, sends targets flying off into the distance
		//
		//more or less represents the concussion blast. i can only assume such a thing exists because
		// i've never stood infront of a fucking shotgun before
		///////////////////////////////////////////////////////////

		TT_createProjectile(%this, %obj, %slot, TacticalShotgunBlastProjectile, 1);
	}
	else if(!$Pref::Server::TT::DeathStopFiring || %obj.getDamagePercent() < 1.0)
	{
		serverPlay3D(PumpShotgunJamSound,%obj.getPosition());
	}
	%this.TT_displayAmmo(%obj);
	return %p;
}

function tacticalShotgunImage::onEject(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%this.TT_displayAmmo(%obj);
}

function tacticalShotgunImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftto);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function tacticalShotgunImage::onReloaded(%this,%obj,%slot)
{
	%this.TT_incrementReload(%obj, %slot);
	%this.TT_displayAmmo(%obj);
}