// If you have no idea where a TT_ function came from, chances are it came from Tier 1
if(ForceRequiredAddon("Weapon_Package_Tier1") == $Error::AddOn_NotFound)
{
	error("ERROR: Weapon_Package_Explosive1 - required add-on Weapon_Package_Tier1 not found");
	return;
}

if($RTB::Hooks::ServerControl)
{
	// Check for Blockland Glass and if it is enabled, do a hack so we don't hog the pref list
	if(isFunction(registerPreferenceAddon))
		%mod = "Weapon_Package_Tier1";
	else
		%mod = "Weapon_Package_Explosive1";

	RTB_registerPref("Display Grenade Count","Tier+Tactical | Grenades","$Pref::Server::TT::DisplayNades","bool",%mod,1,0,1);
	RTB_registerPref("Players Drop Grenades","Tier+Tactical | Grenades","$Pref::Server::TT::PlayerNadeDrop","bool",%mod,1,0,1);
	RTB_registerPref("Bots Drop Grenades","Tier+Tactical | Grenades","$Pref::Server::TT::BotNadeDrop","bool",%mod,0,0,1);
	RTB_registerPref("Infinite Grenades for Players","Tier+Tactical | Grenades","$Pref::Server::TT::PlayerInfNades","bool",%mod,0,0,1);
	RTB_registerPref("Infinite Grenades for Bots","Tier+Tactical | Grenades","$Pref::Server::TT::BotInfNades","bool",%mod,0,0,1);
	// remove grenades from inventory when you run out
	RTB_registerPref("Clear Unusable Grenades","Tier+Tactical | Grenades","$Pref::Server::TT::RemoveOnNoNades","bool",%mod,0,0,1);
	// stops grenade bag from showing up in item list (in case you don't want to use it), requires server restart
   RTB_registerPref("Disable Grenade Pickups","Tier+Tactical | Grenades","$Pref::Server::TT::DisableNadePickups","bool",%mod,0,1,1);
   // disable all datablocks from explosive 1, except for grenade pickup, requires server restart
   RTB_registerPref("Disable Explosive 1 Weapons","Tier+Tactical | Grenades","$Pref::Server::TT::DisableExplosive1","bool",%mod,0,1,1);

	if(!$Pref::Server::TT::DisableExplosive1)
	{
		// allows molotov to deal reduced damage to slayer teammates even with friendly fire off
		// if you kill allies it's still a teamkill
		RTB_registerPref("Molotov Friendly Fire Override","Tier+Tactical | Grenades","$Pref::Server::TT::MolNadeTeamkill","bool",%mod,0,0,1);
		// this fixes a bug where each molotov flame can only damage one player per tick
		RTB_registerPref("Molotov Targeting Bugfix","Tier+Tactical | Grenades","$Pref::Server::TT::MolNadeTargetBugfix","bool",%mod,1,0,1);

		RTB_registerPref("Starting Conc' Grenades","Tier+Tactical | Starting Grenades","$Pref::Server::TT::StartfragNades","int 0 10",%mod,4,0,1);
		RTB_registerPref("Starting Stick Grenades","Tier+Tactical | Starting Grenades","$Pref::Server::TT::StartstickNades","int 0 10",%mod,3,0,1);
		RTB_registerPref("Starting Molotovs","Tier+Tactical | Starting Grenades","$Pref::Server::TT::StartmolNades","int 0 10",%mod,2,0,1);

		RTB_registerPref("Maximum Conc' Grenades","Tier+Tactical | Maximum Grenades","$Pref::Server::TT::MaxfragNades","int 0 10",%mod,4,0,1);
		RTB_registerPref("Maximum Stick Grenades","Tier+Tactical | Maximum Grenades","$Pref::Server::TT::MaxstickNades","int 0 10",%mod,3,0,1);
		RTB_registerPref("Maximum Molotovs","Tier+Tactical | Maximum Grenades","$Pref::Server::TT::MaxmolNades","int 0 10",%mod,2,0,1);
	}
}
else
{
	TT_defaultIfUnset("DisplayNades", 1);
	TT_defaultIfUnset("PlayerNadeDrop", 1);
	TT_defaultIfUnset("BotNadeDrop", 0);
	TT_defaultIfUnset("PlayerInfNades", 0);
	TT_defaultIfUnset("BotInfNades", 0);
	TT_defaultIfUnset("RemoveOnNoNades", 0);
	TT_defaultIfUnset("DisableNadePickups", 0);
	TT_defaultIfUnset("DisableExplosive1", 0);
	TT_defaultIfUnset("MolNadeTeamkill", 0);
	TT_defaultIfUnset("MolNadeTargetBugfix", 1);
	TT_defaultIfUnset("StartfragNades", 4);
	TT_defaultIfUnset("StartstickNades", 3);
	TT_defaultIfUnset("StartmolNades", 2);
	TT_defaultIfUnset("MaxfragNades", 4);
	TT_defaultIfUnset("MaxstickNades", 3);
	TT_defaultIfUnset("MaxmolNades", 2);
}

if($Pref::Server::TT::DisableExplosive1)
{
   warn("WARNING: Weapon_Package_Explosive1 - datablocks disabled, set $Pref::Server::TT::DisableExplosive1 to 0 to re-enable them");
   return;
}

if(ForceRequiredAddon("Projectile_GravityRocket") == $Error::AddOn_NotFound)
{
	error("ERROR: Weapon_Package_Explosive1 - required add-on Projectile_GravityRocket not found");
}
else if(!isFile("add-ons/weapon_rocket_launcher/server.cs")) // what we want are the .dts files, so ForceRequiredAddOn isn't needed
{
	error("ERROR: Weapon_Package_Explosive1 - required add-on Weapon_Rocket_Launcher not found");
}
else
{
	exec("./Item_GrenadeBag.cs");
	exec("./Support_PrjLoop.cs");
	exec("./Weapon_stickgrenade.cs");
	exec("./Weapon_fraggrenade.cs");
	exec("./Weapon_petrbomb.cs");
}

TT_registerAmmoSet("tt_bag", "Grenade Bag", false);

TT_registerAmmoType("fragNades", "Conc' Grenade", "Conc' Grenades", true, "tt", "nades", "tt_bag");
TT_registerAmmoType("stickNades", "Stick Grenade", "Stick Grenades", true, "tt", "nades", "tt_bag");
TT_registerAmmoType("molNades", "Molotov", "Molotovs", true, "tt", "nades", "tt_bag");
