function TT_defaultIfUnset(%pref, %default, %category)
{
   if(%category $= "")
      %category = "TT";
   if($Pref::Server["::" @ %category @ "::" @ %pref] $= "")
      $Pref::Server["::" @ %category @ "::" @ %pref] = %default;
}

if($RTB::Hooks::ServerControl)
{
	// Check for Blockland Glass and if it is enabled, do a hack so we don't hog the pref list
	if(isFunction(registerPreferenceAddon))
		%mod = "Weapon_Package_Tier1";
	else
		%mod = "Weapon_Package_Medic1";

	RTB_registerPref("Teams Can Heal Enemies","Tier+Tactical | Medical","$Pref::Server::TT::MedicHealEnemy","bool",%mod,0,0,1);
	RTB_registerPref("Can Heal Bots","Tier+Tactical | Medical","$Pref::Server::TT::MedicHealBots","bool",%mod,0,0,1);
}
else
{
	TT_defaultIfUnset("MedicHealEnemy", 0);
	TT_defaultIfUnset("MedicHealBots", 0);
}

//medigun.cs
//we need the gun add-on for this, so force it to load
if(ForceRequiredAddOn("Weapon_Gun") == $Error::AddOn_NotFound)
{
   //we don't have the gun, so we're screwed
   error("ERROR: Weapon_Package_Medic1 - required add-on Weapon_Gun not found");
}
else
{
	exec("./Support_ImageAltTrigger.cs");
	exec("./Item_GauzeGun.cs");
	exec("./Item_Stimpack.cs");
   exec("./emote_heal.cs");
}

// think of this like minigameCanDamage but for healing
// make sure %client exists or is 0, and that %targetObject exists
function TT_canHeal(%client, %targetObject)
{
	if(%client && (%targetObject.getType() & $TypeMasks::PlayerObjectType) && ($Pref::Server::TT::MedicHealBots || %targetObject.getClassName() $= "Player"))
	{
		if(isObject(%mini = getMinigameFromObject(%client)))
		{
			if(%mini == getMinigameFromObject(%targetObject))
			{
				if(!$Pref::Server::TT::MedicHealEnemy && %mini.isSlayerMinigame)
				{
					%team1 = %client.getTeam();
					if(isObject(%targetObject.client))
						%team2 = %targetObject.client.getTeam();
					else
						%team2 = %targetObject.getTeam();
					if(!%team1 || %team1.isAlliedTeam(%team2))
						return 1;
				}
				else
				{
					return 1;
				}
			}
		}
		else if($Server::LAN && !isObject(getMinigameFromObject(%targetObject)))
		{
			return 1;
		}
		// this allows you to heal your own hole bots outside of minigame
		else if(isObject(%targetObject.spawnBrick) && %targetObject.getClassName() $= "AIPlayer")
		{
			if(%targetObject.spawnBrick.getGroup().bl_id == getBL_IDFromObject(%client) || %targetObject.spawnBrick.getGroup().bl_id == 888888)
				return 1;
		}
	}
	return 0;
}

// %obj - projectile
// %col - whatever you hit
// %healBurst - amount to heal before any healing over time is applied
function TT_projectileHeal(%obj, %col, %healBurst)
{
	if(isObject(%obj.client))
		%healer = %obj.client;
	else if(isObject(%obj.sourceObject))
		%healer = %obj.sourceObject;

	if(TT_canHeal(%healer, %col))
	{
		if(%col.getDamageLevel() >= %healBurst)
			%col.spawnExplosion(healCrossProjectile, %col.getScale());
		%col.setDamageLevel(%col.getDamageLevel() - %healBurst);

		%colName = %col.getPlayerName();
		%healerName = %healer.getPlayerName();
		if(%colName !$= "")
			bottomPrint(%obj.client, "\c6<font:impact:32>" @ %colName @ "<font:impact:18> was healed by you.", 1, 1);
		if(%healerName !$= "")
			bottomPrint(%col.client, "\c6<font:impact:32>" @ %healerName @ "<font:impact:18> is healing you.", 1, 1);
		%col.emote(medigunHealImage);
	}
}